/*-------------------------------------------------------------------------
 *
 * pg_proc_gp.h
 *	  Additional system function definitions.
 *
 * src/include/catalog/pg_proc_gp.h
 *
 * NOTES
 *    This file contains additional Greenplum-added entries into pg_proc,
 *    on top of the upstream entries from pg_proc.h
 *
 *	  The contents of this file are generated from pg_proc.sql by
 *    catullus.pl. DO NOT EDIT MANUALLY!
 *
 *-------------------------------------------------------------------------
 */
/* no guard ifndef, because this should only be included from pg_proc.h */


/* TIDYCAT_BEGIN_PG_PROC_GEN 


   WARNING: DO NOT MODIFY THE FOLLOWING SECTION: 
   Generated by catullus.pl version 8
   on Wed Jul  5 11:25:29 2017

   Please make your changes in pg_proc.sql
*/

/* All GPDB-added functions are here, instead of pg_proc.h. pg_proc.h should */
/* kept as close as possible to the upstream version, to make merging easier. */
/* */
/* This file is translated into DATA rows by catullus.pl. See */
/* README.add_catalog_function for instructions on how to run it. */
/* float4_decum(_float8, float4) => _float8 */ 
DATA(insert OID = 6024 ( float4_decum  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1022 f "1022 700" _null_ _null_ _null_ _null_ float4_decum _null_ _null_ _null_ n ));
DESCR("aggregate inverse transition function");

/* float4_avg_accum(bytea, float4) => bytea */ 
DATA(insert OID = 3106 ( float4_avg_accum  PGNSP PGUID 12 1 0 0 f f t f i 2 0 17 f "17 700" _null_ _null_ _null_ _null_ float4_avg_accum _null_ _null_ _null_ n ));
DESCR("aggregate transition function");

/* float4_avg_decum(bytea, float4) => bytea */ 
DATA(insert OID = 3107 ( float4_avg_decum  PGNSP PGUID 12 1 0 0 f f t f i 2 0 17 f "17 700" _null_ _null_ _null_ _null_ float4_avg_decum _null_ _null_ _null_ n ));
DESCR("aggregate inverse transition function");

/* float8_decum(_float8, float8) => _float8 */ 
DATA(insert OID = 6025 ( float8_decum  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1022 f "1022 701" _null_ _null_ _null_ _null_ float8_decum _null_ _null_ _null_ n ));
DESCR("aggregate inverse transition function");

/* float8_avg_accum(bytea, float8) => bytea */ 
DATA(insert OID = 3108 ( float8_avg_accum  PGNSP PGUID 12 1 0 0 f f t f i 2 0 17 f "17 701" _null_ _null_ _null_ _null_ float8_avg_accum _null_ _null_ _null_ n ));
DESCR("aggregate transition function");

/* float8_avg_decum(bytea, float8) => bytea */ 
DATA(insert OID = 3109 ( float8_avg_decum  PGNSP PGUID 12 1 0 0 f f t f i 2 0 17 f "17 701" _null_ _null_ _null_ _null_ float8_avg_decum _null_ _null_ _null_ n ));
DESCR("aggregate inverse transition function");

/* btgpxlogloccmp(gpxlogloc, gpxlogloc) => int4 */ 
DATA(insert OID = 7081 ( btgpxlogloccmp  PGNSP PGUID 12 1 0 0 f f t f i 2 0 23 f "3310 3310" _null_ _null_ _null_ _null_ btgpxlogloccmp _null_ _null_ _null_ n ));
DESCR("btree less-equal-greater");


/* MPP -- array_add -- special for prospective customer  */
/* array_add(_int4, _int4) => _int4 */ 
DATA(insert OID = 6012 ( array_add  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1007 f "1007 1007" _null_ _null_ _null_ _null_ array_int4_add _null_ _null_ _null_ n ));
DESCR("itemwise add two integer arrays");

/* array_agg_transfn(internal, anyelement) => internal */ 
DATA(insert OID = 6096 ( array_agg_transfn  PGNSP PGUID 12 1 0 0 f f f f i 2 0 2281 f "2281 2283" _null_ _null_ _null_ _null_ array_agg_transfn _null_ _null_ _null_ n ));
DESCR("array_agg transition function");

/* array_agg_finalfn(internal) => anyarray */ 
DATA(insert OID = 6097 ( array_agg_finalfn  PGNSP PGUID 12 1 0 0 f f f f i 1 0 2277 f "2281" _null_ _null_ _null_ _null_ array_agg_finalfn _null_ _null_ _null_ n ));
DESCR("array_agg final function");

/* array_agg(anyelement) => anyarray */ 
DATA(insert OID = 6098 ( array_agg  PGNSP PGUID 12 1 0 0 t f f f i 1 0 2277 f "2283" _null_ _null_ _null_ _null_ aggregate_dummy _null_ _null_ _null_ n ));
DESCR("concatenate aggregate input into an array");

/* string_agg_transfn(internal, text) => internal */ 
DATA(insert OID = 3534 ( string_agg_transfn  PGNSP PGUID 12 1 0 0 f f f f i 2 0 2281 f "2281 25" _null_ _null_ _null_ _null_ string_agg_transfn _null_ _null_ _null_ n ));
DESCR("string_agg(text) transition function");

/* string_agg_delim_transfn(internal, text, text) => internal */ 
DATA(insert OID = 3535 ( string_agg_delim_transfn  PGNSP PGUID 12 1 0 0 f f f f i 3 0 2281 f "2281 25 25" _null_ _null_ _null_ _null_ string_agg_delim_transfn _null_ _null_ _null_ n ));
DESCR("string_agg(text, text) transition function");

/* string_agg_finalfn(internal) => text */ 
DATA(insert OID = 3536 ( string_agg_finalfn  PGNSP PGUID 12 1 0 0 f f f f i 1 0 25 f "2281" _null_ _null_ _null_ _null_ string_agg_finalfn _null_ _null_ _null_ n ));
DESCR("string_agg final function");

/* string_agg(text) => text */ 
DATA(insert OID = 3537 ( string_agg  PGNSP PGUID 12 1 0 0 t f f f i 1 0 25 f "25" _null_ _null_ _null_ _null_ aggregate_dummy _null_ _null_ _null_ n ));
DESCR("concatenate aggregate input into an string");

/* string_agg(text, text) => text */ 
DATA(insert OID = 3538 ( string_agg  PGNSP PGUID 12 1 0 0 t f f f i 2 0 25 f "25 25" _null_ _null_ _null_ _null_ aggregate_dummy _null_ _null_ _null_ n ));
DESCR("concatenate aggregate input into an string with delimiter");

/* current_query() => text */ 
DATA(insert OID = 820 ( current_query  PGNSP PGUID 12 1 0 0 f f f f v 0 0 25 f "" _null_ _null_ _null_ _null_ current_query _null_ _null_ _null_ n ));
DESCR("returns the currently executing query");

/* int8dec(int8) => int8 */ 
DATA(insert OID = 3546 ( int8dec  PGNSP PGUID 12 1 0 0 f f t f i 1 0 20 f "20" _null_ _null_ _null_ _null_ int8dec _null_ _null_ _null_ n ));

/* interval_interval_div("interval", "interval") => float8 */ 
DATA(insert OID = 6115 ( interval_interval_div  PGNSP PGUID 12 1 0 0 f f t f i 2 0 701 f "1186 1186" _null_ _null_ _null_ _null_ interval_interval_div _null_ _null_ _null_ n ));
DESCR("divide");

/* interval_interval_mod("interval", "interval") => "interval" */ 
DATA(insert OID = 6116 ( interval_interval_mod  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1186 f "1186 1186" _null_ _null_ _null_ _null_ interval_interval_mod _null_ _null_ _null_ n ));
DESCR("modulus");


/* System-view support functions  */
/* pg_get_partition_def(oid) => text */ 
DATA(insert OID = 5024 ( pg_get_partition_def  PGNSP PGUID 12 1 0 0 f f t f s 1 0 25 f "26" _null_ _null_ _null_ _null_ pg_get_partition_def _null_ _null_ _null_ n ));

/* pg_get_partition_def(oid, bool) => text */ 
DATA(insert OID = 5025 ( pg_get_partition_def  PGNSP PGUID 12 1 0 0 f f t f s 2 0 25 f "26 16" _null_ _null_ _null_ _null_ pg_get_partition_def_ext _null_ _null_ _null_ n ));
DESCR("partition configuration for a given relation");

/* pg_get_partition_def(oid, bool, bool) => text */ 
DATA(insert OID = 5034 ( pg_get_partition_def  PGNSP PGUID 12 1 0 0 f f t f s 3 0 25 f "26 16 16" _null_ _null_ _null_ _null_ pg_get_partition_def_ext2 _null_ _null_ _null_ n ));
DESCR("partition configuration for a given relation");

/* pg_get_partition_rule_def(oid) => text */ 
DATA(insert OID = 5027 ( pg_get_partition_rule_def  PGNSP PGUID 12 1 0 0 f f t f s 1 0 25 f "26" _null_ _null_ _null_ _null_ pg_get_partition_rule_def _null_ _null_ _null_ n ));

/* pg_get_partition_rule_def(oid, bool) => text */ 
DATA(insert OID = 5028 ( pg_get_partition_rule_def  PGNSP PGUID 12 1 0 0 f f t f s 2 0 25 f "26 16" _null_ _null_ _null_ _null_ pg_get_partition_rule_def_ext _null_ _null_ _null_ n ));
DESCR("partition configuration for a given rule");

/* pg_get_partition_template_def(oid, bool, bool) => text */ 
DATA(insert OID = 5037 ( pg_get_partition_template_def  PGNSP PGUID 12 1 0 0 f f t f s 3 0 25 f "26 16 16" _null_ _null_ _null_ _null_ pg_get_partition_template_def _null_ _null_ _null_ n ));
DESCR("ALTER statement to recreate subpartition templates for a give relation");

/* pg_get_keywords(OUT word text, OUT catcode "char", OUT catdesc text) => SETOF pg_catalog.record */ 
DATA(insert OID = 821 ( pg_get_keywords  PGNSP PGUID 12 1 1000 0 f f t t s 0 0 2249 f "" "{25,18,25}" "{o,o,o}" "{word,catcode,catdesc}" _null_ pg_get_keywords _null_ _null_ _null_ n ));
DESCR("list of SQL keywords");

/* pg_typeof("any") => regtype */ 
DATA(insert OID = 822 ( pg_typeof  PGNSP PGUID 12 1 0 0 f f f f s 1 0 2206 f "2276" _null_ _null_ _null_ _null_ pg_typeof _null_ _null_ _null_ n ));
DESCR("returns the type of the argument");

/* numeric_dec("numeric") => "numeric" */ 
DATA(insert OID = 6997 ( numeric_dec  PGNSP PGUID 12 1 0 0 f f t f i 1 0 1700 f "1700" _null_ _null_ _null_ _null_ numeric_dec _null_ _null_ _null_ n ));
DESCR("increment by one");


/* Sequences and time series */
/* interval_bound(numeric, numeric) => numeric */ 
DATA(insert OID = 2991 ( interval_bound  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1700 f "1700 1700" _null_ _null_ _null_ _null_ numeric_interval_bound _null_ _null_ _null_ n ));
DESCR("boundary of the interval containing the given value");

/* interval_bound(numeric, numeric, int4) => numeric */ 
DATA(insert OID = 2992 ( interval_bound  PGNSP PGUID 12 1 0 0 f f f f i 3 0 1700 f "1700 1700 23" _null_ _null_ _null_ _null_ numeric_interval_bound_shift _null_ _null_ _null_ n ));
DESCR("boundary of the interval containing the given value");

/* interval_bound(numeric, numeric, int4, numeric) => numeric */ 
DATA(insert OID = 2993 ( interval_bound  PGNSP PGUID 12 1 0 0 f f f f i 4 0 1700 f "1700 1700 23 1700" _null_ _null_ _null_ _null_ numeric_interval_bound_shift_rbound _null_ _null_ _null_ n ));
DESCR("boundary of the interval containing the given value");

/* interval_bound(timestamp, "interval") => timestamp */ 
DATA(insert OID = 2994 ( interval_bound  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1114 f "1114 1186" _null_ _null_ _null_ _null_ timestamp_interval_bound _null_ _null_ _null_ n ));
DESCR("boundary of the interval containing the given value");

/* interval_bound(timestamp, "interval", int4) => timestamp */ 
DATA(insert OID = 2995 ( interval_bound  PGNSP PGUID 12 1 0 0 f f f f i 3 0 1114 f "1114 1186 23" _null_ _null_ _null_ _null_ timestamp_interval_bound_shift _null_ _null_ _null_ n ));
DESCR("boundary of the interval containing the given value");

/* interval_bound(timestamp, "interval", int4, timestamp) => timestamp */ 
DATA(insert OID = 2996 ( interval_bound  PGNSP PGUID 12 1 0 0 f f f f i 4 0 1114 f "1114 1186 23 1114" _null_ _null_ _null_ _null_ timestamp_interval_bound_shift_reg _null_ _null_ _null_ n ));
DESCR("boundary of the interval containing the given value");

/* interval_bound(timestamptz, "interval") => timestamptz */ 
DATA(insert OID = 2997 ( interval_bound  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1184 f "1184 1186" _null_ _null_ _null_ _null_ timestamptz_interval_bound _null_ _null_ _null_ n ));
DESCR("boundary of the interval containing the given value");

/* interval_bound(timestamptz, "interval", int4) => timestamptz */ 
DATA(insert OID = 2998 ( interval_bound  PGNSP PGUID 12 1 0 0 f f f f i 3 0 1184 f "1184 1186 23" _null_ _null_ _null_ _null_ timestamptz_interval_bound_shift _null_ _null_ _null_ n ));
DESCR("boundary of the interval containing the given value");

/* interval_bound(timestamptz, "interval", int4, timestamptz) => timestamptz */ 
DATA(insert OID = 2999 ( interval_bound  PGNSP PGUID 12 1 0 0 f f f f i 4 0 1184 f "1184 1186 23 1184" _null_ _null_ _null_ _null_ timestamptz_interval_bound_shift_reg _null_ _null_ _null_ n ));
DESCR("boundary of the interval containing the given value");


/* Aggregate-related functions  */
/* numeric_avg_accum(bytea, "numeric") => bytea */ 
DATA(insert OID = 3102 ( numeric_avg_accum  PGNSP PGUID 12 1 0 0 f f t f i 2 0 17 f "17 1700" _null_ _null_ _null_ _null_ numeric_avg_accum _null_ _null_ _null_ n ));
DESCR("aggregate transition function");

/* numeric_decum(_numeric, "numeric") => _numeric */ 
DATA(insert OID = 7309 ( numeric_decum  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1231 f "1231 1700" _null_ _null_ _null_ _null_ numeric_decum _null_ _null_ _null_ n ));
DESCR("aggregate inverse transition function");

/* numeric_avg_decum(bytea, "numeric") => bytea */ 
DATA(insert OID = 3103 ( numeric_avg_decum  PGNSP PGUID 12 1 0 0 f f t f i 2 0 17 f "17 1700" _null_ _null_ _null_ _null_ numeric_avg_decum _null_ _null_ _null_ n ));
DESCR("aggregate inverse transition function");

/* int2_decum(_numeric, int2) => _numeric */ 
DATA(insert OID = 7306 ( int2_decum  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1231 f "1231 21" _null_ _null_ _null_ _null_ int2_decum _null_ _null_ _null_ n ));
DESCR("aggregate inverse transition function");

/* int4_decum(_numeric, int4) => _numeric */ 
DATA(insert OID = 7307 ( int4_decum  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1231 f "1231 23" _null_ _null_ _null_ _null_ int4_decum _null_ _null_ _null_ n ));
DESCR("aggregate inverse transition function");

/* int8_decum(_numeric, int8) => _numeric */ 
DATA(insert OID = 7308 ( int8_decum  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1231 f "1231 20" _null_ _null_ _null_ _null_ int8_decum _null_ _null_ _null_ n ));
DESCR("aggregate inverse transition function");

/* int2_invsum(int8, int2) => int8 */ 
DATA(insert OID = 7008 ( int2_invsum  PGNSP PGUID 12 1 0 0 f f f f i 2 0 20 f "20 21" _null_ _null_ _null_ _null_ int2_invsum _null_ _null_ _null_ n ));
DESCR("SUM(int2) inverse transition function");

/* int4_invsum(int8, int4) => int8 */ 
DATA(insert OID = 7009 ( int4_invsum  PGNSP PGUID 12 1 0 0 f f f f i 2 0 20 f "20 23" _null_ _null_ _null_ _null_ int4_invsum _null_ _null_ _null_ n ));
DESCR("SUM(int4) inverse transition function");

/* int8_invsum("numeric", int8) => "numeric" */ 
DATA(insert OID = 7010 ( int8_invsum  PGNSP PGUID 12 1 0 0 f f f f i 2 0 1700 f "1700 20" _null_ _null_ _null_ _null_ int8_invsum _null_ _null_ _null_ n ));
DESCR("SUM(int8) inverse transition function");

/* interval_decum(_interval, "interval") => _interval */ 
DATA(insert OID = 6038 ( interval_decum  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1187 f "1187 1186" _null_ _null_ _null_ _null_ interval_decum _null_ _null_ _null_ n ));
DESCR("aggregate inverse transition function");

/* int8_avg_accum(bytea, int8) => bytea */ 
DATA(insert OID = 3100 ( int8_avg_accum  PGNSP PGUID 12 1 0 0 f f t f i 2 0 17 f "17 20" _null_ _null_ _null_ _null_ int8_avg_accum _null_ _null_ _null_ n ));
DESCR("AVG(int8) transition function");

/* int2_avg_decum(bytea, int2) => bytea */ 
DATA(insert OID = 6019 ( int2_avg_decum  PGNSP PGUID 12 1 0 0 f f t f i 2 0 17 f "17 21" _null_ _null_ _null_ _null_ int2_avg_decum _null_ _null_ _null_ n ));
DESCR("AVG(int2) transition function");

/* int4_avg_decum(bytea, int4) => bytea */ 
DATA(insert OID = 6020 ( int4_avg_decum  PGNSP PGUID 12 1 0 0 f f t f i 2 0 17 f "17 23" _null_ _null_ _null_ _null_ int4_avg_decum _null_ _null_ _null_ n ));
DESCR("AVG(int4) transition function");

/* int8_avg_decum(bytea, int8) => bytea */ 
DATA(insert OID = 3101 ( int8_avg_decum  PGNSP PGUID 12 1 0 0 f f t f i 2 0 17 f "17 20" _null_ _null_ _null_ _null_ int8_avg_decum _null_ _null_ _null_ n ));
DESCR("AVG(int8) transition function");

/* pg_stat_get_backend_waiting_reason(int4) => text */ 
DATA(insert OID = 2897 ( pg_stat_get_backend_waiting_reason  PGNSP PGUID 12 1 0 0 f f t f s 1 0 25 f "23" _null_ _null_ _null_ _null_ pg_stat_get_backend_waiting_reason _null_ _null_ _null_ n ));
DESCR("Statistics: Reason backend is waiting for");

/* pg_stat_get_queue_num_exec(oid) => int8 */ 
DATA(insert OID = 6031 ( pg_stat_get_queue_num_exec  PGNSP PGUID 12 1 0 0 f f t f s 1 0 20 f "26" _null_ _null_ _null_ _null_ pg_stat_get_queue_num_exec _null_ _null_ _null_ n ));
DESCR("Statistics: Number of queries that executed in queue");

/* pg_stat_get_queue_num_wait(oid) => int8 */ 
DATA(insert OID = 6032 ( pg_stat_get_queue_num_wait  PGNSP PGUID 12 1 0 0 f f t f s 1 0 20 f "26" _null_ _null_ _null_ _null_ pg_stat_get_queue_num_wait _null_ _null_ _null_ n ));
DESCR("Statistics: Number of queries that waited in queue");

/* pg_stat_get_queue_elapsed_exec(oid) => int8 */ 
DATA(insert OID = 6033 ( pg_stat_get_queue_elapsed_exec  PGNSP PGUID 12 1 0 0 f f t f s 1 0 20 f "26" _null_ _null_ _null_ _null_ pg_stat_get_queue_elapsed_exec _null_ _null_ _null_ n ));
DESCR("Statistics:  Elapsed seconds for queries that executed in queue");

/* pg_stat_get_queue_elapsed_wait(oid) => int8 */ 
DATA(insert OID = 6034 ( pg_stat_get_queue_elapsed_wait  PGNSP PGUID 12 1 0 0 f f t f s 1 0 20 f "26" _null_ _null_ _null_ _null_ pg_stat_get_queue_elapsed_wait _null_ _null_ _null_ n ));
DESCR("Statistics:  Elapsed seconds for queries that waited in queue");

/* pg_stat_get_backend_session_id(int4) => int4 */ 
DATA(insert OID = 6039 ( pg_stat_get_backend_session_id  PGNSP PGUID 12 1 0 0 f f t f s 1 0 23 f "23" _null_ _null_ _null_ _null_ pg_stat_get_backend_session_id _null_ _null_ _null_ n ));
DESCR("Statistics: Greenplum session id of backend");

/* pg_renice_session(int4, int4) => int4 */ 
DATA(insert OID = 6042 ( pg_renice_session  PGNSP PGUID 12 1 0 0 f f t f v 2 0 23 f "23 23" _null_ _null_ _null_ _null_ pg_renice_session _null_ _null_ _null_ n ));
DESCR("change priority of all the backends for a given session id");

/* pg_stat_get_activity(IN pid int4, OUT datid oid, OUT procpid int4, OUT usesysid oid, OUT application_name text, OUT current_query text, OUT waiting bool, OUT xact_start timestamptz, OUT query_start timestamptz, OUT backend_start timestamptz, OUT client_addr inet, OUT client_port int4, OUT sess_id int4, OUT waiting_reason text, OUT rsgid oid, OUT rsgname text, OUT rsgqueueduration interval) => SETOF pg_catalog.record */ 
DATA(insert OID = 6071 ( pg_stat_get_activity  PGNSP PGUID 12 1 1000 0 f f f t v 1 0 2249 f "23" "{23,26,23,26,25,25,16,1184,1184,1184,869,23,23,25,26,25,1186}" "{i,o,o,o,o,o,o,o,o,o,o,o,o,o,o,o,o}" "{pid,datid,procpid,usesysid,application_name,current_query,waiting,xact_start,query_start,backend_start,client_addr,client_port,sess_id,waiting_reason,rsgid,rsgname,rsgqueueduration}" _null_ pg_stat_get_activity _null_ _null_ _null_ n ));
DESCR("statistics: information about currently active backends");

/* pg_stat_get_wal_senders(OUT pid int4, OUT state text, OUT sent_location text, OUT write_location text, OUT flush_location text, OUT replay_location text, OUT sync_priority int4, OUT sync_state text) => SETOF pg_catalog.record */ 
DATA(insert OID = 3099 ( pg_stat_get_wal_senders  PGNSP PGUID 12 1 1000 0 f f f t s 0 0 2249 f "" "{23,25,25,25,25,25,23,25}" "{o,o,o,o,o,o,o,o}" "{pid,state,sent_location,write_location,flush_location,replay_location,sync_priority,sync_state}" _null_ pg_stat_get_wal_senders _null_ _null_ _null_ n ));
DESCR("statistics: information about currently active replication");

/* pg_terminate_backend(int4) => bool */ 
DATA(insert OID = 6118 ( pg_terminate_backend  PGNSP PGUID 12 1 0 0 f f t f v 1 0 16 f "23" _null_ _null_ _null_ _null_ pg_terminate_backend _null_ _null_ _null_ n ));
DESCR("terminate a server process");

/* pg_terminate_backend(int4, text) => bool */ 
DATA(insert OID = 951 ( pg_terminate_backend  PGNSP PGUID 12 1 0 0 f f t f v 2 0 16 f "23 25" _null_ _null_ _null_ _null_ pg_terminate_backend_msg _null_ _null_ _null_ n ));
DESCR("terminate a server process");

/* pg_resgroup_get_status_kv(IN prop_in text, OUT rsgid oid, OUT prop text, OUT value text) => SETOF pg_catalog.record */ 
DATA(insert OID = 6065 ( pg_resgroup_get_status_kv  PGNSP PGUID 12 1 1000 0 f f f t v 1 0 2249 f "25" "{25,26,25,25}" "{i,o,o,o}" "{prop_in,rsgid,prop,value}" _null_ pg_resgroup_get_status_kv _null_ _null_ _null_ n ));
DESCR("statistics: information about resource groups in key-value style");

/* pg_resgroup_get_status(IN groupid oid, OUT groupid oid, OUT num_running int4, OUT num_queueing int4, OUT num_queued int4, OUT num_executed int4, OUT total_queue_duration interval, OUT cpu_usage json, OUT memory_usage json) => SETOF pg_catalog.record */ 
DATA(insert OID = 6066 ( pg_resgroup_get_status  PGNSP PGUID 12 1 1000 0 f f f t v 1 0 2249 f "26" "{26,26,23,23,23,23,1186,114,114}" "{i,o,o,o,o,o,o,o,o}" "{groupid,groupid,num_running,num_queueing,num_queued,num_executed,total_queue_duration,cpu_usage,memory_usage}" _null_ pg_resgroup_get_status _null_ _null_ _null_ n ));
DESCR("statistics: information about resource groups");

/* pg_resqueue_status() => SETOF record */ 
DATA(insert OID = 6030 ( pg_resqueue_status  PGNSP PGUID 12 1 1000 0 f f t t v 0 0 2249 f "" _null_ _null_ _null_ _null_ pg_resqueue_status _null_ _null_ _null_ n ));
DESCR("Return resource queue information");

/* pg_resqueue_status_kv() => SETOF record */ 
DATA(insert OID = 6069 ( pg_resqueue_status_kv  PGNSP PGUID 12 1 1000 0 f f t t v 0 0 2249 f "" _null_ _null_ _null_ _null_ pg_resqueue_status_kv _null_ _null_ _null_ n ));
DESCR("Return resource queue information");

/* pg_file_read(text, int8, int8) => text */ 
DATA(insert OID = 6045 ( pg_file_read  PGNSP PGUID 12 1 0 0 f f t f v 3 0 25 f "25 20 20" _null_ _null_ _null_ _null_ pg_read_file _null_ _null_ _null_ n ));
DESCR("Read text from a file");

/* pg_logfile_rotate() => bool */ 
DATA(insert OID = 6046 ( pg_logfile_rotate  PGNSP PGUID 12 1 0 0 f f t f v 0 0 16 f "" _null_ _null_ _null_ _null_ pg_rotate_logfile _null_ _null_ _null_ n ));
DESCR("Rotate log file");

/* pg_file_write(text, text, bool) => int8 */ 
DATA(insert OID = 6047 ( pg_file_write  PGNSP PGUID 12 1 0 0 f f t f v 3 0 20 f "25 25 16" _null_ _null_ _null_ _null_ pg_file_write _null_ _null_ _null_ n ));
DESCR("Write text to a file");

/* pg_file_rename(text, text, text) => bool */ 
DATA(insert OID = 6048 ( pg_file_rename  PGNSP PGUID 12 1 0 0 f f f f v 3 0 16 f "25 25 25" _null_ _null_ _null_ _null_ pg_file_rename _null_ _null_ _null_ n ));
DESCR("Rename a file");

/* pg_file_unlink(text) => bool */ 
DATA(insert OID = 6049 ( pg_file_unlink  PGNSP PGUID 12 1 0 0 f f t f v 1 0 16 f "25" _null_ _null_ _null_ _null_ pg_file_unlink _null_ _null_ _null_ n ));
DESCR("Delete (unlink) a file");

/* pg_logdir_ls() => SETOF record */ 
DATA(insert OID = 6050 ( pg_logdir_ls  PGNSP PGUID 12 1 1000 0 f f t t v 0 0 2249 f "" _null_ _null_ _null_ _null_ pg_logdir_ls _null_ _null_ _null_ n ));
DESCR("ls the log dir");

/* pg_file_length(text) => int8 */ 
DATA(insert OID = 6051 ( pg_file_length  PGNSP PGUID 12 1 0 0 f f t f v 1 0 20 f "25" _null_ _null_ _null_ _null_ pg_file_length _null_ _null_ _null_ n ));
DESCR("Get the length of a file (via stat)");


/* Aggregates (moved here from pg_aggregate for 7.3)  */
/* max(gpxlogloc) => gpxlogloc */ 
DATA(insert OID = 3332 ( max  PGNSP PGUID 12 1 0 0 t f f f i 1 0 3310 f "3310" _null_ _null_ _null_ _null_ aggregate_dummy _null_ _null_ _null_ n ));

/* min(gpxlogloc) => gpxlogloc */ 
DATA(insert OID = 3333 ( min  PGNSP PGUID 12 1 0 0 t f f f i 1 0 3310 f "3310" _null_ _null_ _null_ _null_ aggregate_dummy _null_ _null_ _null_ n ));


/* MPP Aggregate -- array_sum -- special for prospective customer.  */
/* array_sum(_int4) => _int4 */ 
DATA(insert OID = 6013 ( array_sum  PGNSP PGUID 12 1 0 0 t f f f i 1 0 1007 f "1007" _null_ _null_ _null_ _null_ aggregate_dummy _null_ _null_ _null_ n ));


/* Window functions (similar to aggregates)  */
/* row_number() => int8 */ 
DATA(insert OID = 7000 ( row_number  PGNSP PGUID 12 1 0 0 f f f f i 0 0 20 t "" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));


#define ROW_NUMBER_OID 7000
#define ROW_NUMBER_TYPE 20
/* rank() => int8 */ 
DATA(insert OID = 7001 ( rank  PGNSP PGUID 12 1 0 0 f f f f i 0 0 20 t "" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* dense_rank() => int8 */ 
DATA(insert OID = 7002 ( dense_rank  PGNSP PGUID 12 1 0 0 f f f f i 0 0 20 t "" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

#define WINDOW_PERCENT_RANK 7003
/* percent_rank() => float8 */ 
DATA(insert OID = 7003 ( percent_rank  PGNSP PGUID 12 1 0 0 f f f f i 0 0 701 t "" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

#define CUME_DIST_OID 7004
/* cume_dist() => float8 */ 
DATA(insert OID = 7004 ( cume_dist  PGNSP PGUID 12 1 0 0 f f f f i 0 0 701 t "" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

#define WINDOW_NTILE_INT4 7005
/* ntile(int4) => int8 */ 
DATA(insert OID = 7005 ( ntile  PGNSP PGUID 12 1 0 0 f f f f i 1 0 20 t "23" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

#define WINDOW_NTILE_INT8 7006
/* ntile(int8) => int8 */ 
DATA(insert OID = 7006 ( ntile  PGNSP PGUID 12 1 0 0 f f f f i 1 0 20 t "20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

#define WINDOW_NTILE_NUMERIC 7007
/* ntile("numeric") => int8 */ 
DATA(insert OID = 7007 ( ntile  PGNSP PGUID 12 1 0 0 f f f f i 1 0 20 t "1700" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));


/*  XXX for now, window functions with arguments, just cite numeric = 1700, need to overload.  */
/* first_value(bool) => bool */ 
DATA(insert OID = 7017 ( first_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 16 t "16" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* first_value("char") => "char" */ 
DATA(insert OID = 7018 ( first_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 18 t "18" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* first_value(cidr) => cidr */ 
DATA(insert OID = 7019 ( first_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 650 t "650" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* first_value(circle) => circle */ 
DATA(insert OID = 7020 ( first_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 718 t "718" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* first_value(float4) => float4 */ 
DATA(insert OID = 7021 ( first_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 700 t "700" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* first_value(float8) => float8 */ 
DATA(insert OID = 7022 ( first_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 701 t "701" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* first_value(inet) => inet */ 
DATA(insert OID = 7023 ( first_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 869 t "869" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* first_value("interval") => "interval" */ 
DATA(insert OID = 7024 ( first_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 1186 t "1186" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* first_value(line) => line */ 
DATA(insert OID = 7025 ( first_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 628 t "628" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* first_value(lseg) => lseg */ 
DATA(insert OID = 7026 ( first_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 601 t "601" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* first_value(macaddr) => macaddr */ 
DATA(insert OID = 7027 ( first_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 829 t "829" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* first_value(int2) => int2 */ 
DATA(insert OID = 7028 ( first_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 21 t "21" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* first_value(int4) => int4 */ 
DATA(insert OID = 7029 ( first_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 23 t "23" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* first_value(int8) => int8 */ 
DATA(insert OID = 7030 ( first_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 20 t "20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* first_value(money) => money */ 
DATA(insert OID = 7031 ( first_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 790 t "790" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* first_value(name) => name */ 
DATA(insert OID = 7032 ( first_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 19 t "19" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* first_value("numeric") => "numeric" */ 
DATA(insert OID = 7033 ( first_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 1700 t "1700" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* first_value(oid) => oid */ 
DATA(insert OID = 7034 ( first_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 26 t "26" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* first_value(path) => path */ 
DATA(insert OID = 7035 ( first_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 602 t "602" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* first_value(point) => point */ 
DATA(insert OID = 7036 ( first_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 600 t "600" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* first_value(polygon) => polygon */ 
DATA(insert OID = 7037 ( first_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 604 t "604" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* first_value(reltime) => reltime */ 
DATA(insert OID = 7038 ( first_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 703 t "703" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* first_value(text) => text */ 
DATA(insert OID = 7039 ( first_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 25 t "25" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* first_value(tid) => tid */ 
DATA(insert OID = 7040 ( first_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 27 t "27" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* first_value("time") => "time" */ 
DATA(insert OID = 7041 ( first_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 1083 t "1083" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* first_value("timestamp") => "timestamp" */ 
DATA(insert OID = 7042 ( first_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 1114 t "1114" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* first_value(timestamptz) => timestamptz */ 
DATA(insert OID = 7043 ( first_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 1184 t "1184" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* first_value(timetz) => timetz */ 
DATA(insert OID = 7044 ( first_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 1266 t "1266" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* first_value(varbit) => varbit */ 
DATA(insert OID = 7045 ( first_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 1562 t "1562" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* first_value("varchar") => "varchar" */ 
DATA(insert OID = 7046 ( first_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 1043 t "1043" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* first_value(xid) => xid */ 
DATA(insert OID = 7047 ( first_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 28 t "28" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* first_value(bytea) => bytea */ 
DATA(insert OID = 7232 ( first_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 17 t "17" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* first_value("bit") => "bit" */ 
DATA(insert OID = 7256 ( first_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 1560 t "1560" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* first_value(box) => box */ 
DATA(insert OID = 7272 ( first_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 603 t "603" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* first_value(anyarray) => anyarray */ 
DATA(insert OID = 7288 ( first_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 2277 t "2277" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* last_value(int4) => int4 */ 
DATA(insert OID = 7012 ( last_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 23 t "23" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* last_value(int2) => int2 */ 
DATA(insert OID = 7013 ( last_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 21 t "21" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* last_value(int8) => int8 */ 
DATA(insert OID = 7014 ( last_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 20 t "20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* last_value("numeric") => "numeric" */ 
DATA(insert OID = 7015 ( last_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 1700 t "1700" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* last_value(text) => text */ 
DATA(insert OID = 7016 ( last_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 25 t "25" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* last_value(bool) => bool */ 
DATA(insert OID = 7063 ( last_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 16 t "16" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* last_value("char") => "char" */ 
DATA(insert OID = 7072 ( last_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 18 t "18" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* last_value(cidr) => cidr */ 
DATA(insert OID = 7073 ( last_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 650 t "650" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* last_value(circle) => circle */ 
DATA(insert OID = 7048 ( last_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 718 t "718" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* last_value(float4) => float4 */ 
DATA(insert OID = 7049 ( last_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 700 t "700" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* last_value(float8) => float8 */ 
DATA(insert OID = 7050 ( last_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 701 t "701" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* last_value(inet) => inet */ 
DATA(insert OID = 7051 ( last_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 869 t "869" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* last_value("interval") => "interval" */ 
DATA(insert OID = 7052 ( last_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 1186 t "1186" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* last_value(line) => line */ 
DATA(insert OID = 7053 ( last_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 628 t "628" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* last_value(lseg) => lseg */ 
DATA(insert OID = 7054 ( last_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 601 t "601" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* last_value(macaddr) => macaddr */ 
DATA(insert OID = 7055 ( last_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 829 t "829" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* last_value(money) => money */ 
DATA(insert OID = 7056 ( last_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 790 t "790" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* last_value(name) => name */ 
DATA(insert OID = 7057 ( last_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 19 t "19" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* last_value(oid) => oid */ 
DATA(insert OID = 7058 ( last_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 26 t "26" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* last_value(path) => path */ 
DATA(insert OID = 7059 ( last_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 602 t "602" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* last_value(point) => point */ 
DATA(insert OID = 7060 ( last_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 600 t "600" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* last_value(polygon) => polygon */ 
DATA(insert OID = 7061 ( last_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 604 t "604" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* last_value(reltime) => reltime */ 
DATA(insert OID = 7062 ( last_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 703 t "703" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* last_value(tid) => tid */ 
DATA(insert OID = 7064 ( last_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 27 t "27" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* last_value("time") => "time" */ 
DATA(insert OID = 7065 ( last_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 1083 t "1083" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* last_value("timestamp") => "timestamp" */ 
DATA(insert OID = 7066 ( last_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 1114 t "1114" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* last_value(timestamptz) => timestamptz */ 
DATA(insert OID = 7067 ( last_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 1184 t "1184" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* last_value(timetz) => timetz */ 
DATA(insert OID = 7068 ( last_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 1266 t "1266" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* last_value(varbit) => varbit */ 
DATA(insert OID = 7069 ( last_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 1562 t "1562" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* last_value("varchar") => "varchar" */ 
DATA(insert OID = 7070 ( last_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 1043 t "1043" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* last_value(xid) => xid */ 
DATA(insert OID = 7071 ( last_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 28 t "28" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* last_value(bytea) => bytea */ 
DATA(insert OID = 7238 ( last_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 17 t "17" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* last_value("bit") => "bit" */ 
DATA(insert OID = 7258 ( last_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 1560 t "1560" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* last_value(box) => box */ 
DATA(insert OID = 7274 ( last_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 603 t "603" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* last_value(anyarray) => anyarray */ 
DATA(insert OID = 7290 ( last_value  PGNSP PGUID 12 1 0 0 f f f f i 1 0 2277 t "2277" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(bool, int8, bool) => bool */ 
DATA(insert OID = 7675 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 3 0 16 t "16 20 16" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(bool, int8) => bool */ 
DATA(insert OID = 7491 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 2 0 16 t "16 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(bool) => bool */ 
DATA(insert OID = 7493 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 1 0 16 t "16" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag("char", int8, "char") => "char" */ 
DATA(insert OID = 7495 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 3 0 18 t "18 20 18" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag("char", int8) => "char" */ 
DATA(insert OID = 7497 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 2 0 18 t "18 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag("char") => "char" */ 
DATA(insert OID = 7499 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 1 0 18 t "18" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(cidr, int8, cidr) => cidr */ 
DATA(insert OID = 7501 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 3 0 650 t "650 20 650" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(cidr, int8) => cidr */ 
DATA(insert OID = 7503 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 2 0 650 t "650 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(cidr) => cidr */ 
DATA(insert OID = 7505 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 1 0 650 t "650" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(circle, int8, circle) => circle */ 
DATA(insert OID = 7507 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 3 0 718 t "718 20 718" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(circle, int8) => circle */ 
DATA(insert OID = 7509 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 2 0 718 t "718 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(circle) => circle */ 
DATA(insert OID = 7511 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 1 0 718 t "718" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(float4, int8, float4) => float4 */ 
DATA(insert OID = 7513 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 3 0 700 t "700 20 700" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(float4, int8) => float4 */ 
DATA(insert OID = 7515 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 2 0 700 t "700 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(float4) => float4 */ 
DATA(insert OID = 7517 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 1 0 700 t "700" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(float8, int8, float8) => float8 */ 
DATA(insert OID = 7519 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 3 0 701 t "701 20 701" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(float8, int8) => float8 */ 
DATA(insert OID = 7521 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 2 0 701 t "701 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(float8) => float8 */ 
DATA(insert OID = 7523 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 1 0 701 t "701" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(inet, int8, inet) => inet */ 
DATA(insert OID = 7525 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 3 0 869 t "869 20 869" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(inet, int8) => inet */ 
DATA(insert OID = 7527 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 2 0 869 t "869 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(inet) => inet */ 
DATA(insert OID = 7529 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 1 0 869 t "869" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag("interval", int8, "interval") => "interval" */ 
DATA(insert OID = 7531 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 3 0 1186 t "1186 20 1186" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag("interval", int8) => "interval" */ 
DATA(insert OID = 7533 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 2 0 1186 t "1186 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag("interval") => "interval" */ 
DATA(insert OID = 7535 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 1 0 1186 t "1186" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(line, int8, line) => line */ 
DATA(insert OID = 7537 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 3 0 628 t "628 20 628" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(line, int8) => line */ 
DATA(insert OID = 7539 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 2 0 628 t "628 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(line) => line */ 
DATA(insert OID = 7541 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 1 0 628 t "628" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(lseg, int8, lseg) => lseg */ 
DATA(insert OID = 7543 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 3 0 601 t "601 20 601" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(lseg, int8) => lseg */ 
DATA(insert OID = 7545 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 2 0 601 t "601 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(lseg) => lseg */ 
DATA(insert OID = 7547 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 1 0 601 t "601" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(macaddr, int8, macaddr) => macaddr */ 
DATA(insert OID = 7549 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 3 0 829 t "829 20 829" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(macaddr, int8) => macaddr */ 
DATA(insert OID = 7551 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 2 0 829 t "829 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(macaddr) => macaddr */ 
DATA(insert OID = 7553 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 1 0 829 t "829" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(int2, int8, int2) => int2 */ 
DATA(insert OID = 7555 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 3 0 21 t "21 20 21" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(int2, int8) => int2 */ 
DATA(insert OID = 7557 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 2 0 21 t "21 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(int2) => int2 */ 
DATA(insert OID = 7559 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 1 0 21 t "21" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(int4, int8, int4) => int4 */ 
DATA(insert OID = 7561 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 3 0 23 t "23 20 23" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(int4, int8) => int4 */ 
DATA(insert OID = 7563 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 2 0 23 t "23 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(int4) => int4 */ 
DATA(insert OID = 7565 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 1 0 23 t "23" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(int8, int8, int8) => int8 */ 
DATA(insert OID = 7567 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 3 0 20 t "20 20 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(int8, int8) => int8 */ 
DATA(insert OID = 7569 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 2 0 20 t "20 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(int8) => int8 */ 
DATA(insert OID = 7571 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 1 0 20 t "20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(money, int8, money) => money */ 
DATA(insert OID = 7573 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 3 0 790 t "790 20 790" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(money, int8) => money */ 
DATA(insert OID = 7575 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 2 0 790 t "790 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(money) => money */ 
DATA(insert OID = 7577 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 1 0 790 t "790" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(name, int8, name) => name */ 
DATA(insert OID = 7579 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 3 0 19 t "19 20 19" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(name, int8) => name */ 
DATA(insert OID = 7581 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 2 0 19 t "19 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(name) => name */ 
DATA(insert OID = 7583 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 1 0 19 t "19" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag("numeric", int8, "numeric") => "numeric" */ 
DATA(insert OID = 7585 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 3 0 1700 t "1700 20 1700" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag("numeric", int8) => "numeric" */ 
DATA(insert OID = 7587 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 2 0 1700 t "1700 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag("numeric") => "numeric" */ 
DATA(insert OID = 7589 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 1 0 1700 t "1700" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(oid, int8, oid) => oid */ 
DATA(insert OID = 7591 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 3 0 26 t "26 20 26" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(oid, int8) => oid */ 
DATA(insert OID = 7593 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 2 0 26 t "26 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(oid) => oid */ 
DATA(insert OID = 7595 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 1 0 26 t "26" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(path, int8, path) => path */ 
DATA(insert OID = 7597 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 3 0 602 t "602 20 602" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(path, int8) => path */ 
DATA(insert OID = 7599 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 2 0 602 t "602 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(path) => path */ 
DATA(insert OID = 7601 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 1 0 602 t "602" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(point, int8, point) => point */ 
DATA(insert OID = 7603 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 3 0 600 t "600 20 600" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(point, int8) => point */ 
DATA(insert OID = 7605 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 2 0 600 t "600 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(point) => point */ 
DATA(insert OID = 7607 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 1 0 600 t "600" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(polygon, int8, polygon) => polygon */ 
DATA(insert OID = 7609 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 3 0 604 t "604 20 604" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(polygon, int8) => polygon */ 
DATA(insert OID = 7611 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 2 0 604 t "604 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(polygon) => polygon */ 
DATA(insert OID = 7613 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 1 0 604 t "604" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(reltime, int8, reltime) => reltime */ 
DATA(insert OID = 7615 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 3 0 703 t "703 20 703" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(reltime, int8) => reltime */ 
DATA(insert OID = 7617 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 2 0 703 t "703 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(reltime) => reltime */ 
DATA(insert OID = 7619 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 1 0 703 t "703" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(text, int8, text) => text */ 
DATA(insert OID = 7621 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 3 0 25 t "25 20 25" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(text, int8) => text */ 
DATA(insert OID = 7623 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 2 0 25 t "25 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(text) => text */ 
DATA(insert OID = 7625 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 1 0 25 t "25" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(tid, int8, tid) => tid */ 
DATA(insert OID = 7627 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 3 0 27 t "27 20 27" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(tid, int8) => tid */ 
DATA(insert OID = 7629 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 2 0 27 t "27 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(tid) => tid */ 
DATA(insert OID = 7631 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 1 0 27 t "27" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag("time", int8, "time") => "time" */ 
DATA(insert OID = 7633 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 3 0 1083 t "1083 20 1083" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag("time", int8) => "time" */ 
DATA(insert OID = 7635 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 2 0 1083 t "1083 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag("time") => "time" */ 
DATA(insert OID = 7637 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 1 0 1083 t "1083" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag("timestamp", int8, "timestamp") => "timestamp" */ 
DATA(insert OID = 7639 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 3 0 1114 t "1114 20 1114" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag("timestamp", int8) => "timestamp" */ 
DATA(insert OID = 7641 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 2 0 1114 t "1114 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag("timestamp") => "timestamp" */ 
DATA(insert OID = 7643 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 1 0 1114 t "1114" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(timestamptz, int8, timestamptz) => timestamptz */ 
DATA(insert OID = 7645 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 3 0 1184 t "1184 20 1184" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(timestamptz, int8) => timestamptz */ 
DATA(insert OID = 7647 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 2 0 1184 t "1184 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(timestamptz) => timestamptz */ 
DATA(insert OID = 7649 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 1 0 1184 t "1184" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(timetz, int8, timetz) => timetz */ 
DATA(insert OID = 7651 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 3 0 1266 t "1266 20 1266" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(timetz, int8) => timetz */ 
DATA(insert OID = 7653 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 2 0 1266 t "1266 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(timetz) => timetz */ 
DATA(insert OID = 7655 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 1 0 1266 t "1266" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(varbit, int8, varbit) => varbit */ 
DATA(insert OID = 7657 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 3 0 1562 t "1562 20 1562" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(varbit, int8) => varbit */ 
DATA(insert OID = 7659 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 2 0 1562 t "1562 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(varbit) => varbit */ 
DATA(insert OID = 7661 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 1 0 1562 t "1562" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag("varchar", int8, "varchar") => "varchar" */ 
DATA(insert OID = 7663 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 3 0 1043 t "1043 20 1043" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag("varchar", int8) => "varchar" */ 
DATA(insert OID = 7665 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 2 0 1043 t "1043 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag("varchar") => "varchar" */ 
DATA(insert OID = 7667 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 1 0 1043 t "1043" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(xid, int8, xid) => xid */ 
DATA(insert OID = 7669 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 3 0 28 t "28 20 28" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(xid, int8) => xid */ 
DATA(insert OID = 7671 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 2 0 28 t "28 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(xid) => xid */ 
DATA(insert OID = 7673 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 1 0 28 t "28" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(anyarray, int8, anyarray) => anyarray */ 
DATA(insert OID = 7211 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 3 0 2277 t "2277 20 2277" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(anyarray, int8) => anyarray */ 
DATA(insert OID = 7212 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 2 0 2277 t "2277 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(anyarray) => anyarray */ 
DATA(insert OID = 7213 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 1 0 2277 t "2277" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(bytea) => bytea */ 
DATA(insert OID = 7226 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 1 0 17 t "17" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(bytea, int8) => bytea */ 
DATA(insert OID = 7228 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 2 0 17 t "17 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(bytea, int8, bytea) => bytea */ 
DATA(insert OID = 7230 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 3 0 17 t "17 20 17" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag("bit") => "bit" */ 
DATA(insert OID = 7250 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 1 0 1560 t "1560" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag("bit", int8) => "bit" */ 
DATA(insert OID = 7252 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 2 0 1560 t "1560 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag("bit", int8, "bit") => "bit" */ 
DATA(insert OID = 7254 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 3 0 1560 t "1560 20 1560" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(box) => box */ 
DATA(insert OID = 7266 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 1 0 603 t "603" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(box, int8) => box */ 
DATA(insert OID = 7268 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 2 0 603 t "603 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lag(box, int8, box) => box */ 
DATA(insert OID = 7270 ( lag  PGNSP PGUID 12 1 0 0 f f f f i 3 0 603 t "603 20 603" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(int4, int8, int4) => int4 */ 
DATA(insert OID = 7011 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 3 0 23 t "23 20 23" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(int4, int8) => int4 */ 
DATA(insert OID = 7074 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 2 0 23 t "23 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(int4) => int4 */ 
DATA(insert OID = 7075 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 1 0 23 t "23" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(bool, int8, bool) => bool */ 
DATA(insert OID = 7310 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 3 0 16 t "16 20 16" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(bool, int8) => bool */ 
DATA(insert OID = 7312 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 2 0 16 t "16 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(bool) => bool */ 
DATA(insert OID = 7314 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 1 0 16 t "16" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead("char", int8, "char") => "char" */ 
DATA(insert OID = 7316 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 3 0 18 t "18 20 18" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead("char", int8) => "char" */ 
DATA(insert OID = 7318 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 2 0 18 t "18 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead("char") => "char" */ 
DATA(insert OID = 7320 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 1 0 18 t "18" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(cidr, int8, cidr) => cidr */ 
DATA(insert OID = 7322 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 3 0 650 t "650 20 650" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(cidr, int8) => cidr */ 
DATA(insert OID = 7324 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 2 0 650 t "650 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(cidr) => cidr */ 
DATA(insert OID = 7326 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 1 0 650 t "650" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(circle, int8, circle) => circle */ 
DATA(insert OID = 7328 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 3 0 718 t "718 20 718" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(circle, int8) => circle */ 
DATA(insert OID = 7330 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 2 0 718 t "718 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(circle) => circle */ 
DATA(insert OID = 7332 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 1 0 718 t "718" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(float4, int8, float4) => float4 */ 
DATA(insert OID = 7334 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 3 0 700 t "700 20 700" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(float4, int8) => float4 */ 
DATA(insert OID = 7336 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 2 0 700 t "700 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(float4) => float4 */ 
DATA(insert OID = 7338 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 1 0 700 t "700" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(float8, int8, float8) => float8 */ 
DATA(insert OID = 7340 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 3 0 701 t "701 20 701" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(float8, int8) => float8 */ 
DATA(insert OID = 7342 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 2 0 701 t "701 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(float8) => float8 */ 
DATA(insert OID = 7344 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 1 0 701 t "701" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(inet, int8, inet) => inet */ 
DATA(insert OID = 7346 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 3 0 869 t "869 20 869" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(inet, int8) => inet */ 
DATA(insert OID = 7348 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 2 0 869 t "869 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(inet) => inet */ 
DATA(insert OID = 7350 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 1 0 869 t "869" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead("interval", int8, "interval") => "interval" */ 
DATA(insert OID = 7352 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 3 0 1186 t "1186 20 1186" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead("interval", int8) => "interval" */ 
DATA(insert OID = 7354 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 2 0 1186 t "1186 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead("interval") => "interval" */ 
DATA(insert OID = 7356 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 1 0 1186 t "1186" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(line, int8, line) => line */ 
DATA(insert OID = 7358 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 3 0 628 t "628 20 628" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(line, int8) => line */ 
DATA(insert OID = 7360 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 2 0 628 t "628 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(line) => line */ 
DATA(insert OID = 7362 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 1 0 628 t "628" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(lseg, int8, lseg) => lseg */ 
DATA(insert OID = 7364 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 3 0 601 t "601 20 601" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(lseg, int8) => lseg */ 
DATA(insert OID = 7366 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 2 0 601 t "601 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(lseg) => lseg */ 
DATA(insert OID = 7368 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 1 0 601 t "601" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(macaddr, int8, macaddr) => macaddr */ 
DATA(insert OID = 7370 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 3 0 829 t "829 20 829" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(macaddr, int8) => macaddr */ 
DATA(insert OID = 7372 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 2 0 829 t "829 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(macaddr) => macaddr */ 
DATA(insert OID = 7374 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 1 0 829 t "829" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(int2, int8, int2) => int2 */ 
DATA(insert OID = 7376 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 3 0 21 t "21 20 21" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(int2, int8) => int2 */ 
DATA(insert OID = 7378 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 2 0 21 t "21 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(int2) => int2 */ 
DATA(insert OID = 7380 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 1 0 21 t "21" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(int8, int8, int8) => int8 */ 
DATA(insert OID = 7382 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 3 0 20 t "20 20 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(int8, int8) => int8 */ 
DATA(insert OID = 7384 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 2 0 20 t "20 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(int8) => int8 */ 
DATA(insert OID = 7386 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 1 0 20 t "20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(money, int8, money) => money */ 
DATA(insert OID = 7388 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 3 0 790 t "790 20 790" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(money, int8) => money */ 
DATA(insert OID = 7390 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 2 0 790 t "790 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(money) => money */ 
DATA(insert OID = 7392 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 1 0 790 t "790" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(name, int8, name) => name */ 
DATA(insert OID = 7394 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 3 0 19 t "19 20 19" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(name, int8) => name */ 
DATA(insert OID = 7396 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 2 0 19 t "19 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(name) => name */ 
DATA(insert OID = 7398 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 1 0 19 t "19" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead("numeric", int8, "numeric") => "numeric" */ 
DATA(insert OID = 7400 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 3 0 1700 t "1700 20 1700" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead("numeric", int8) => "numeric" */ 
DATA(insert OID = 7402 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 2 0 1700 t "1700 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead("numeric") => "numeric" */ 
DATA(insert OID = 7404 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 1 0 1700 t "1700" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(oid, int8, oid) => oid */ 
DATA(insert OID = 7406 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 3 0 26 t "26 20 26" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(oid, int8) => oid */ 
DATA(insert OID = 7408 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 2 0 26 t "26 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(oid) => oid */ 
DATA(insert OID = 7410 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 1 0 26 t "26" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(path, int8, path) => path */ 
DATA(insert OID = 7412 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 3 0 602 t "602 20 602" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(path, int8) => path */ 
DATA(insert OID = 7414 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 2 0 602 t "602 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(path) => path */ 
DATA(insert OID = 7416 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 1 0 602 t "602" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(point, int8, point) => point */ 
DATA(insert OID = 7418 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 3 0 600 t "600 20 600" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(point, int8) => point */ 
DATA(insert OID = 7420 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 2 0 600 t "600 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(point) => point */ 
DATA(insert OID = 7422 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 1 0 600 t "600" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(polygon, int8, polygon) => polygon */ 
DATA(insert OID = 7424 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 3 0 604 t "604 20 604" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(polygon, int8) => polygon */ 
DATA(insert OID = 7426 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 2 0 604 t "604 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(polygon) => polygon */ 
DATA(insert OID = 7428 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 1 0 604 t "604" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(reltime, int8, reltime) => reltime */ 
DATA(insert OID = 7430 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 3 0 703 t "703 20 703" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(reltime, int8) => reltime */ 
DATA(insert OID = 7432 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 2 0 703 t "703 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(reltime) => reltime */ 
DATA(insert OID = 7434 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 1 0 703 t "703" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(text, int8, text) => text */ 
DATA(insert OID = 7436 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 3 0 25 t "25 20 25" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(text, int8) => text */ 
DATA(insert OID = 7438 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 2 0 25 t "25 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(text) => text */ 
DATA(insert OID = 7440 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 1 0 25 t "25" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(tid, int8, tid) => tid */ 
DATA(insert OID = 7442 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 3 0 27 t "27 20 27" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(tid, int8) => tid */ 
DATA(insert OID = 7444 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 2 0 27 t "27 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(tid) => tid */ 
DATA(insert OID = 7446 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 1 0 27 t "27" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead("time", int8, "time") => "time" */ 
DATA(insert OID = 7448 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 3 0 1083 t "1083 20 1083" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead("time", int8) => "time" */ 
DATA(insert OID = 7450 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 2 0 1083 t "1083 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead("time") => "time" */ 
DATA(insert OID = 7452 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 1 0 1083 t "1083" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead("timestamp", int8, "timestamp") => "timestamp" */ 
DATA(insert OID = 7454 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 3 0 1114 t "1114 20 1114" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead("timestamp", int8) => "timestamp" */ 
DATA(insert OID = 7456 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 2 0 1114 t "1114 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead("timestamp") => "timestamp" */ 
DATA(insert OID = 7458 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 1 0 1114 t "1114" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(timestamptz, int8, timestamptz) => timestamptz */ 
DATA(insert OID = 7460 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 3 0 1184 t "1184 20 1184" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(timestamptz, int8) => timestamptz */ 
DATA(insert OID = 7462 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 2 0 1184 t "1184 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(timestamptz) => timestamptz */ 
DATA(insert OID = 7464 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 1 0 1184 t "1184" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(timetz, int8, timetz) => timetz */ 
DATA(insert OID = 7466 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 3 0 1266 t "1266 20 1266" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(timetz, int8) => timetz */ 
DATA(insert OID = 7468 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 2 0 1266 t "1266 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(timetz) => timetz */ 
DATA(insert OID = 7470 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 1 0 1266 t "1266" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(varbit, int8, varbit) => varbit */ 
DATA(insert OID = 7472 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 3 0 1562 t "1562 20 1562" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(varbit, int8) => varbit */ 
DATA(insert OID = 7474 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 2 0 1562 t "1562 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(varbit) => varbit */ 
DATA(insert OID = 7476 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 1 0 1562 t "1562" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead("varchar", int8, "varchar") => "varchar" */ 
DATA(insert OID = 7478 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 3 0 1043 t "1043 20 1043" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead("varchar", int8) => "varchar" */ 
DATA(insert OID = 7480 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 2 0 1043 t "1043 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead("varchar") => "varchar" */ 
DATA(insert OID = 7482 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 1 0 1043 t "1043" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(xid, int8, xid) => xid */ 
DATA(insert OID = 7484 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 3 0 28 t "28 20 28" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(xid, int8) => xid */ 
DATA(insert OID = 7486 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 2 0 28 t "28 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(xid) => xid */ 
DATA(insert OID = 7488 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 1 0 28 t "28" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(anyarray, int8, anyarray) => anyarray */ 
DATA(insert OID = 7214 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 3 0 2277 t "2277 20 2277" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(anyarray, int8) => anyarray */ 
DATA(insert OID = 7215 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 2 0 2277 t "2277 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(anyarray) => anyarray */ 
DATA(insert OID = 7216 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 1 0 2277 t "2277" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(bytea) => bytea */ 
DATA(insert OID = 7220 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 1 0 17 t "17" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(bytea, int8) => bytea */ 
DATA(insert OID = 7222 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 2 0 17 t "17 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(bytea, int8, bytea) => bytea */ 
DATA(insert OID = 7224 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 3 0 17 t "17 20 17" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead("bit") => "bit" */ 
DATA(insert OID = 7244 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 1 0 1560 t "1560" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead("bit", int8) => "bit" */ 
DATA(insert OID = 7246 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 2 0 1560 t "1560 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead("bit", int8, "bit") => "bit" */ 
DATA(insert OID = 7248 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 3 0 1560 t "1560 20 1560" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(box) => box */ 
DATA(insert OID = 7260 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 1 0 603 t "603" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(box, int8) => box */ 
DATA(insert OID = 7262 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 2 0 603 t "603 20" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));

/* lead(box, int8, box) => box */ 
DATA(insert OID = 7264 ( lead  PGNSP PGUID 12 1 0 0 f f f f i 3 0 603 t "603 20 603" _null_ _null_ _null_ _null_ window_dummy _null_ _null_ _null_ n ));


/*- */
/* generate_series("timestamp", "timestamp", "interval") => SETOF "timestamp" */ 
DATA(insert OID = 6113 ( generate_series  PGNSP PGUID 12 1 1000 0 f f t t v 3 0 1114 f "1114 1114 1186" _null_ _null_ _null_ _null_ generate_series_timestamp _null_ _null_ _null_ n ));
DESCR("non-persistent series generator");

/* generate_series("timestamptz", "timestamptz", "interval") => SETOF "timestamptz" */ 
DATA(insert OID = 6114 ( generate_series  PGNSP PGUID 12 1 1000 0 f f t t v 3 0 1184 f "1184 1184 1186" _null_ _null_ _null_ _null_ generate_series_timestamptz _null_ _null_ _null_ n ));
DESCR("non-persistent series generator");


/* Greenplum Analytic functions */
/* int2_matrix_accum(_int8, _int2) => _int8 */ 
DATA(insert OID = 3212 ( int2_matrix_accum  PGNSP PGUID 12 1 0 0 f f f f i 2 0 1016 f "1016 1005" _null_ _null_ _null_ _null_ matrix_add _null_ _null_ _null_ n ));
DESCR("perform matrix addition on two conformable matrices");

/* int4_matrix_accum(_int8, _int4) => _int8 */ 
DATA(insert OID = 3213 ( int4_matrix_accum  PGNSP PGUID 12 1 0 0 f f f f i 2 0 1016 f "1016 1007" _null_ _null_ _null_ _null_ matrix_add _null_ _null_ _null_ n ));
DESCR("perform matrix addition on two conformable matrices");

/* int8_matrix_accum(_int8, _int8) => _int8 */ 
DATA(insert OID = 3214 ( int8_matrix_accum  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1016 f "1016 1016" _null_ _null_ _null_ _null_ matrix_add _null_ _null_ _null_ n ));
DESCR("perform matrix addition on two conformable matrices");

/* float8_matrix_accum(_float8, _float8) => _float8 */ 
DATA(insert OID = 3215 ( float8_matrix_accum  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1022 f "1022 1022" _null_ _null_ _null_ _null_ matrix_add _null_ _null_ _null_ n ));
DESCR("perform matrix addition on two conformable matrices");

/* sum(_int2) => _int8 */ 
DATA(insert OID = 3216 ( sum  PGNSP PGUID 12 1 0 0 t f f f i 1 0 1016 f "1005" _null_ _null_ _null_ _null_ aggregate_dummy _null_ _null_ _null_ n ));

/* sum(_int4) => _int8 */ 
DATA(insert OID = 3217 ( sum  PGNSP PGUID 12 1 0 0 t f f f i 1 0 1016 f "1007" _null_ _null_ _null_ _null_ aggregate_dummy _null_ _null_ _null_ n ));

/* sum(_int8) => _int8 */ 
DATA(insert OID = 3218 ( sum  PGNSP PGUID 12 1 0 0 t f f f i 1 0 1016 f "1016" _null_ _null_ _null_ _null_ aggregate_dummy _null_ _null_ _null_ n ));

/* sum(_float8) => _float8 */ 
DATA(insert OID = 3219 ( sum  PGNSP PGUID 12 1 0 0 t f f f i 1 0 1022 f "1022" _null_ _null_ _null_ _null_ aggregate_dummy _null_ _null_ _null_ n ));


/* 3220 - reserved for sum(numeric[])  */
/* int4_pivot_accum(_int4, _text, text, int4) => _int4 */ 
DATA(insert OID = 3225 ( int4_pivot_accum  PGNSP PGUID 12 1 0 0 f f f f i 4 0 1007 f "1007 1009 25 23" _null_ _null_ _null_ _null_ int4_pivot_accum _null_ _null_ _null_ n ));

/* pivot_sum(_text, text, int4) => _int4 */ 
DATA(insert OID = 3226 ( pivot_sum  PGNSP PGUID 12 1 0 0 t f f f i 3 0 1007 f "1009 25 23" _null_ _null_ _null_ _null_ aggregate_dummy _null_ _null_ _null_ n ));

/* int8_pivot_accum(_int8, _text, text, int8) => _int8 */ 
DATA(insert OID = 3227 ( int8_pivot_accum  PGNSP PGUID 12 1 0 0 f f f f i 4 0 1016 f "1016 1009 25 20" _null_ _null_ _null_ _null_ int8_pivot_accum _null_ _null_ _null_ n ));

/* pivot_sum(_text, text, int8) => _int8 */ 
DATA(insert OID = 3228 ( pivot_sum  PGNSP PGUID 12 1 0 0 t f f f i 3 0 1016 f "1009 25 20" _null_ _null_ _null_ _null_ aggregate_dummy _null_ _null_ _null_ n ));

/* float8_pivot_accum(_float8, _text, text, float8) => _float8 */ 
DATA(insert OID = 3229 ( float8_pivot_accum  PGNSP PGUID 12 1 0 0 f f f f i 4 0 1022 f "1022 1009 25 701" _null_ _null_ _null_ _null_ float8_pivot_accum _null_ _null_ _null_ n ));

/* pivot_sum(_text, text, float8) => _float8 */ 
DATA(insert OID = 3230 ( pivot_sum  PGNSP PGUID 12 1 0 0 t f f f i 3 0 1022 f "1009 25 701" _null_ _null_ _null_ _null_ aggregate_dummy _null_ _null_ _null_ n ));

/* unnest(anyarray) => SETOF anyelement */ 
DATA(insert OID = 3240 ( unnest  PGNSP PGUID 12 1 1000 0 f f t t i 1 0 2283 f "2277" _null_ _null_ _null_ _null_ unnest _null_ _null_ _null_ n ));


/* 3241-324? reserved for unpivot, see pivot.c  */
/* gpaotidin(cstring) => gpaotid */ 
DATA(insert OID = 3302 ( gpaotidin  PGNSP PGUID 12 1 0 0 f f t f i 1 0 3300 f "2275" _null_ _null_ _null_ _null_ gpaotidin _null_ _null_ _null_ n ));
DESCR("I/O");

/* gpaotidout(gpaotid) => cstring */ 
DATA(insert OID = 3303 ( gpaotidout  PGNSP PGUID 12 1 0 0 f f t f i 1 0 2275 f "3300" _null_ _null_ _null_ _null_ gpaotidout _null_ _null_ _null_ n ));
DESCR("I/O");

/* gpaotidrecv(internal) => gpaotid */ 
DATA(insert OID = 3304 ( gpaotidrecv  PGNSP PGUID 12 1 0 0 f f t f i 1 0 3300 f "2281" _null_ _null_ _null_ _null_ gpaotidrecv _null_ _null_ _null_ n ));
DESCR("I/O");

/* gpaotidsend(gpaotid) => bytea */ 
DATA(insert OID = 3305 ( gpaotidsend  PGNSP PGUID 12 1 0 0 f f t f i 1 0 17 f "3300" _null_ _null_ _null_ _null_ gpaotidsend _null_ _null_ _null_ n ));
DESCR("I/O");

/* gpxloglocin(cstring) => gpxlogloc */ 
DATA(insert OID = 3312 ( gpxloglocin  PGNSP PGUID 12 1 0 0 f f t f i 1 0 3310 f "2275" _null_ _null_ _null_ _null_ gpxloglocin _null_ _null_ _null_ n ));
DESCR("I/O");

/* gpxloglocout(gpxlogloc) => cstring */ 
DATA(insert OID = 3313 ( gpxloglocout  PGNSP PGUID 12 1 0 0 f f t f i 1 0 2275 f "3310" _null_ _null_ _null_ _null_ gpxloglocout _null_ _null_ _null_ n ));
DESCR("I/O");

/* gpxloglocrecv(internal) => gpxlogloc */ 
DATA(insert OID = 3314 ( gpxloglocrecv  PGNSP PGUID 12 1 0 0 f f t f i 1 0 3310 f "2281" _null_ _null_ _null_ _null_ gpxloglocrecv _null_ _null_ _null_ n ));
DESCR("I/O");

/* gpxloglocsend(gpxlogloc) => bytea */ 
DATA(insert OID = 3315 ( gpxloglocsend  PGNSP PGUID 12 1 0 0 f f t f i 1 0 17 f "3310" _null_ _null_ _null_ _null_ gpxloglocsend _null_ _null_ _null_ n ));
DESCR("I/O");

/* gpxlogloclarger(gpxlogloc, gpxlogloc) => gpxlogloc */ 
DATA(insert OID = 3318 ( gpxlogloclarger  PGNSP PGUID 12 1 0 0 f f t f i 2 0 3310 f "3310 3310" _null_ _null_ _null_ _null_ gpxlogloclarger _null_ _null_ _null_ n ));
DESCR("I/O");

/* gpxloglocsmaller(gpxlogloc, gpxlogloc) => gpxlogloc */ 
DATA(insert OID = 3319 ( gpxloglocsmaller  PGNSP PGUID 12 1 0 0 f f t f i 2 0 3310 f "3310 3310" _null_ _null_ _null_ _null_ gpxloglocsmaller _null_ _null_ _null_ n ));
DESCR("I/O");

/* gpxlogloceq(gpxlogloc, gpxlogloc) => bool */ 
DATA(insert OID = 3331 ( gpxlogloceq  PGNSP PGUID 12 1 0 0 f f t f i 2 0 16 f "3310 3310" _null_ _null_ _null_ _null_ gpxlogloceq _null_ _null_ _null_ n ));
DESCR("I/O");

/* gpxloglocne(gpxlogloc, gpxlogloc) => bool */ 
DATA(insert OID = 3320 ( gpxloglocne  PGNSP PGUID 12 1 0 0 f f t f i 2 0 16 f "3310 3310" _null_ _null_ _null_ _null_ gpxloglocne _null_ _null_ _null_ n ));
DESCR("I/O");

/* gpxlogloclt(gpxlogloc, gpxlogloc) => bool */ 
DATA(insert OID = 3321 ( gpxlogloclt  PGNSP PGUID 12 1 0 0 f f t f i 2 0 16 f "3310 3310" _null_ _null_ _null_ _null_ gpxlogloclt _null_ _null_ _null_ n ));
DESCR("I/O");

/* gpxloglocle(gpxlogloc, gpxlogloc) => bool */ 
DATA(insert OID = 3322 ( gpxloglocle  PGNSP PGUID 12 1 0 0 f f t f i 2 0 16 f "3310 3310" _null_ _null_ _null_ _null_ gpxloglocle _null_ _null_ _null_ n ));
DESCR("I/O");

/* gpxloglocgt(gpxlogloc, gpxlogloc) => bool */ 
DATA(insert OID = 3323 ( gpxloglocgt  PGNSP PGUID 12 1 0 0 f f t f i 2 0 16 f "3310 3310" _null_ _null_ _null_ _null_ gpxloglocgt _null_ _null_ _null_ n ));
DESCR("I/O");

/* gpxloglocge(gpxlogloc, gpxlogloc) => bool */ 
DATA(insert OID = 3324 ( gpxloglocge  PGNSP PGUID 12 1 0 0 f f t f i 2 0 16 f "3310 3310" _null_ _null_ _null_ _null_ gpxloglocge _null_ _null_ _null_ n ));
DESCR("I/O");


/* Greenplum MPP exposed internally-defined functions.  */
/* gp_backup_launch(text, text, text, text, text) => text */ 
DATA(insert OID = 6003 ( gp_backup_launch  PGNSP PGUID 12 1 0 0 f f f f v 5 0 25 f "25 25 25 25 25" _null_ _null_ _null_ _null_ gp_backup_launch__ _null_ _null_ _null_ n ));
DESCR("launch mpp backup on outboard Postgres instances");

/* gp_restore_launch(text, text, text, text, text, text, int4, bool) => text */ 
DATA(insert OID = 6004 ( gp_restore_launch  PGNSP PGUID 12 1 0 0 f f f f v 8 0 25 f "25 25 25 25 25 25 23 16" _null_ _null_ _null_ _null_ gp_restore_launch__ _null_ _null_ _null_ n ));
DESCR("launch mpp restore on outboard Postgres instances");

/* gp_read_backup_file(text, text, regproc) => text */ 
DATA(insert OID = 6005 ( gp_read_backup_file  PGNSP PGUID 12 1 0 0 f f f f v 3 0 25 f "25 25 24" _null_ _null_ _null_ _null_ gp_read_backup_file__ _null_ _null_ _null_ n ));
DESCR("read mpp backup file on outboard Postgres instances");

/* gp_write_backup_file(text, text, text) => text */ 
DATA(insert OID = 6006 ( gp_write_backup_file  PGNSP PGUID 12 1 0 0 f f f f v 3 0 25 f "25 25 25" _null_ _null_ _null_ _null_ gp_write_backup_file__ _null_ _null_ _null_ n ));
DESCR("write mpp backup file on outboard Postgres instances");

/* gp_pgdatabase() => SETOF record */ 
DATA(insert OID = 6007 ( gp_pgdatabase  PGNSP PGUID 12 1 1000 0 f f f t v 0 0 2249 f "" _null_ _null_ _null_ _null_ gp_pgdatabase__ _null_ _null_ _null_ n ));
DESCR("view mpp pgdatabase state");

/* numeric_amalg(_numeric, _numeric) => _numeric */ 
DATA(insert OID = 6008 ( numeric_amalg  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1231 f "1231 1231" _null_ _null_ _null_ _null_ numeric_amalg _null_ _null_ _null_ n ));
DESCR("aggregate preliminary function");

/* numeric_avg_amalg(bytea, bytea) => bytea */ 
DATA(insert OID = 3104 ( numeric_avg_amalg  PGNSP PGUID 12 1 0 0 f f t f i 2 0 17 f "17 17" _null_ _null_ _null_ _null_ numeric_avg_amalg _null_ _null_ _null_ n ));
DESCR("aggregate preliminary function");

/* int8_avg_amalg(bytea, bytea) => bytea */ 
DATA(insert OID = 6009 ( int8_avg_amalg  PGNSP PGUID 12 1 0 0 f f t f i 2 0 17 f "17 17" _null_ _null_ _null_ _null_ int8_avg_amalg _null_ _null_ _null_ n ));
DESCR("aggregate preliminary function");

/* float8_amalg(_float8, _float8) => _float8 */ 
DATA(insert OID = 6010 ( float8_amalg  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1022 f "1022 1022" _null_ _null_ _null_ _null_ float8_amalg _null_ _null_ _null_ n ));
DESCR("aggregate preliminary function");

/* float8_avg_amalg(bytea, bytea) => bytea */ 
DATA(insert OID = 3111 ( float8_avg_amalg  PGNSP PGUID 12 1 0 0 f f t f i 2 0 17 f "17 17" _null_ _null_ _null_ _null_ float8_avg_amalg _null_ _null_ _null_ n ));
DESCR("aggregate preliminary function");

/* interval_amalg(_interval, _interval) => _interval */ 
DATA(insert OID = 6011 ( interval_amalg  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1187 f "1187 1187" _null_ _null_ _null_ _null_ interval_amalg _null_ _null_ _null_ n ));
DESCR("aggregate preliminary function");

/* numeric_demalg(_numeric, _numeric) => _numeric */ 
DATA(insert OID = 6015 ( numeric_demalg  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1231 f "1231 1231" _null_ _null_ _null_ _null_ numeric_demalg _null_ _null_ _null_ n ));
DESCR("aggregate inverse preliminary function");

/* numeric_avg_demalg(bytea, bytea) => bytea */ 
DATA(insert OID = 3105 ( numeric_avg_demalg  PGNSP PGUID 12 1 0 0 f f t f i 2 0 17 f "17 17" _null_ _null_ _null_ _null_ numeric_avg_demalg _null_ _null_ _null_ n ));
DESCR("aggregate inverse preliminary function");

/* int8_avg_demalg(bytea, bytea) => bytea */ 
DATA(insert OID = 6016 ( int8_avg_demalg  PGNSP PGUID 12 1 0 0 f f t f i 2 0 17 f "17 17" _null_ _null_ _null_ _null_ int8_avg_demalg _null_ _null_ _null_ n ));
DESCR("aggregate preliminary function");

/* float8_demalg(_float8, _float8) => _float8 */ 
DATA(insert OID = 6017 ( float8_demalg  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1022 f "1022 1022" _null_ _null_ _null_ _null_ float8_demalg _null_ _null_ _null_ n ));

/* float8_avg_demalg(bytea, bytea) => bytea */ 
DATA(insert OID = 3110 ( float8_avg_demalg  PGNSP PGUID 12 1 0 0 f f t f i 2 0 17 f "17 17" _null_ _null_ _null_ _null_ float8_avg_demalg _null_ _null_ _null_ n ));
DESCR("aggregate inverse preliminary function");

/* interval_demalg(_interval, _interval) => _interval */ 
DATA(insert OID = 6018 ( interval_demalg  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1187 f "1187 1187" _null_ _null_ _null_ _null_ interval_demalg _null_ _null_ _null_ n ));
DESCR("aggregate preliminary function");

/* float8_regr_amalg(_float8, _float8) => _float8 */ 
DATA(insert OID = 6014 ( float8_regr_amalg  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1022 f "1022 1022" _null_ _null_ _null_ _null_ float8_regr_amalg _null_ _null_ _null_ n ));

/* int8(tid) => int8 */ 
DATA(insert OID = 6021 ( int8  PGNSP PGUID 12 1 0 0 f f t f i 1 0 20 f "27" _null_ _null_ _null_ _null_ tidtoi8 _null_ _null_ _null_ n ));
DESCR("convert tid to int8");


#define CDB_PROC_TIDTOI8    6021
/* gp_execution_segment() => SETOF int4 */ 
DATA(insert OID = 6022 ( gp_execution_segment  PGNSP PGUID 12 1 1000 0 f f f t v 0 0 23 f "" _null_ _null_ _null_ _null_ mpp_execution_segment _null_ _null_ _null_ n ));
DESCR("segment executing function");


#define MPP_EXECUTION_SEGMENT_OID 6022
#define MPP_EXECUTION_SEGMENT_TYPE 23
/* pg_highest_oid() => oid */ 
DATA(insert OID = 6023 ( pg_highest_oid  PGNSP PGUID 12 1 0 0 f f t f v 0 0 26 f "" _null_ _null_ _null_ _null_ pg_highest_oid _null_ _null_ _null_ r ));
DESCR("Highest oid used so far");

/* gp_distributed_xacts() => SETOF record */ 
DATA(insert OID = 6035 ( gp_distributed_xacts  PGNSP PGUID 12 1 1000 0 f f f t v 0 0 2249 f "" _null_ _null_ _null_ _null_ gp_distributed_xacts__ _null_ _null_ _null_ n ));
DESCR("view mpp distributed transaction state");

/* gp_distributed_xid() => xid */ 
DATA(insert OID = 6037 ( gp_distributed_xid  PGNSP PGUID 12 1 0 0 f f t f v 0 0 28 f "" _null_ _null_ _null_ _null_ gp_distributed_xid _null_ _null_ _null_ n ));
DESCR("Current distributed transaction id");

/* gp_transaction_log() => SETOF record */ 
DATA(insert OID = 6043 ( gp_transaction_log  PGNSP PGUID 12 1 1000 0 f f f t v 0 0 2249 f "" _null_ _null_ _null_ _null_ gp_transaction_log _null_ _null_ _null_ n ));
DESCR("view logged local transaction status");

/* gp_distributed_log() => SETOF record */ 
DATA(insert OID = 6044 ( gp_distributed_log  PGNSP PGUID 12 1 1000 0 f f f t v 0 0 2249 f "" _null_ _null_ _null_ _null_ gp_distributed_log _null_ _null_ _null_ n ));
DESCR("view logged distributed transaction status");

/* gp_changetracking_log(IN filetype int4, OUT segment_id int2, OUT dbid int2, OUT space oid, OUT db oid, OUT rel oid, OUT xlogloc gpxlogloc, OUT blocknum int4, OUT persistent_tid tid, OUT persistent_sn int8) => SETOF pg_catalog.record */ 
DATA(insert OID = 6435 ( gp_changetracking_log  PGNSP PGUID 12 1 1000 0 f f f t v 1 0 2249 f "23" "{23,21,21,26,26,26,3310,23,27,20}" "{i,o,o,o,o,o,o,o,o,o}" "{filetype,segment_id,dbid,space,db,rel,xlogloc,blocknum,persistent_tid,persistent_sn}" _null_ gp_changetracking_log _null_ _null_ _null_ n ));
DESCR("view logged change tracking records");

/* gp_execution_dbid() => int4 */ 
DATA(insert OID = 6068 ( gp_execution_dbid  PGNSP PGUID 12 1 0 0 f f f f v 0 0 23 f "" _null_ _null_ _null_ _null_ gp_execution_dbid _null_ _null_ _null_ n ));
DESCR("dbid executing function");


/* Greenplum MPP window function implementation */
/* row_number_immed(internal) => int8 */ 
DATA(insert OID = 7100 ( row_number_immed  PGNSP PGUID 12 1 0 0 f f t f i 1 0 20 f "2281" _null_ _null_ _null_ _null_ row_number_immed _null_ _null_ _null_ n ));
DESCR("window immediate function");

/* rank_immed(internal) => int8 */ 
DATA(insert OID = 7101 ( rank_immed  PGNSP PGUID 12 1 0 0 f f t f i 1 0 20 f "2281" _null_ _null_ _null_ _null_ rank_immed _null_ _null_ _null_ n ));
DESCR("window immediate function");

/* dense_rank_immed(internal) => int8 */ 
DATA(insert OID = 7102 ( dense_rank_immed  PGNSP PGUID 12 1 0 0 f f t f i 1 0 20 f "2281" _null_ _null_ _null_ _null_ dense_rank_immed _null_ _null_ _null_ n ));
DESCR("window immediate function");

/* lag_bool(internal, bool, int8, bool) => bool */ 
DATA(insert OID = 7490 ( lag_bool  PGNSP PGUID 12 1 0 0 f f t f i 4 0 16 t "2281 16 20 16" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_bool(internal, bool, int8) => bool */ 
DATA(insert OID = 7492 ( lag_bool  PGNSP PGUID 12 1 0 0 f f t f i 3 0 16 t "2281 16 20" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_bool(internal, bool) => bool */ 
DATA(insert OID = 7494 ( lag_bool  PGNSP PGUID 12 1 0 0 f f t f i 2 0 16 t "2281 16" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_char(internal, "char", int8, "char") => "char" */ 
DATA(insert OID = 7496 ( lag_char  PGNSP PGUID 12 1 0 0 f f t f i 4 0 18 t "2281 18 20 18" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_char(internal, "char", int8) => "char" */ 
DATA(insert OID = 7498 ( lag_char  PGNSP PGUID 12 1 0 0 f f t f i 3 0 18 t "2281 18 20" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_char(internal, "char") => "char" */ 
DATA(insert OID = 7500 ( lag_char  PGNSP PGUID 12 1 0 0 f f t f i 2 0 18 t "2281 18" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_cidr(internal, cidr, int8, cidr) => cidr */ 
DATA(insert OID = 7502 ( lag_cidr  PGNSP PGUID 12 1 0 0 f f t f i 4 0 650 t "2281 650 20 650" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_cidr(internal, cidr, int8) => cidr */ 
DATA(insert OID = 7504 ( lag_cidr  PGNSP PGUID 12 1 0 0 f f t f i 3 0 650 t "2281 650 20" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_cidr(internal, cidr) => cidr */ 
DATA(insert OID = 7506 ( lag_cidr  PGNSP PGUID 12 1 0 0 f f t f i 2 0 650 t "2281 650" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_circle(internal, circle, int8, circle) => circle */ 
DATA(insert OID = 7508 ( lag_circle  PGNSP PGUID 12 1 0 0 f f t f i 4 0 718 t "2281 718 20 718" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_circle(internal, circle, int8) => circle */ 
DATA(insert OID = 7510 ( lag_circle  PGNSP PGUID 12 1 0 0 f f t f i 3 0 718 t "2281 718 20" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_circle(internal, circle) => circle */ 
DATA(insert OID = 7512 ( lag_circle  PGNSP PGUID 12 1 0 0 f f t f i 2 0 718 t "2281 718" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_float4(internal, float4, int8, float4) => float4 */ 
DATA(insert OID = 7514 ( lag_float4  PGNSP PGUID 12 1 0 0 f f t f i 4 0 700 t "2281 700 20 700" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_float4(internal, float4, int8) => float4 */ 
DATA(insert OID = 7516 ( lag_float4  PGNSP PGUID 12 1 0 0 f f t f i 3 0 700 t "2281 700 20" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_float4(internal, float4) => float4 */ 
DATA(insert OID = 7518 ( lag_float4  PGNSP PGUID 12 1 0 0 f f t f i 2 0 700 t "2281 700" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_float8(internal, float8, int8, float8) => float8 */ 
DATA(insert OID = 7520 ( lag_float8  PGNSP PGUID 12 1 0 0 f f t f i 4 0 701 t "2281 701 20 701" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_float8(internal, float8, int8) => float8 */ 
DATA(insert OID = 7522 ( lag_float8  PGNSP PGUID 12 1 0 0 f f t f i 3 0 701 t "2281 701 20" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_float8(internal, float8) => float8 */ 
DATA(insert OID = 7524 ( lag_float8  PGNSP PGUID 12 1 0 0 f f t f i 2 0 701 t "2281 701" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_inet(internal, inet, int8, inet) => inet */ 
DATA(insert OID = 7526 ( lag_inet  PGNSP PGUID 12 1 0 0 f f t f i 4 0 869 t "2281 869 20 869" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_inet(internal, inet, int8) => inet */ 
DATA(insert OID = 7528 ( lag_inet  PGNSP PGUID 12 1 0 0 f f t f i 3 0 869 t "2281 869 20" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_inet(internal, inet) => inet */ 
DATA(insert OID = 7530 ( lag_inet  PGNSP PGUID 12 1 0 0 f f t f i 2 0 869 t "2281 869" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_interval(internal, "interval", int8, "interval") => "interval" */ 
DATA(insert OID = 7532 ( lag_interval  PGNSP PGUID 12 1 0 0 f f t f i 4 0 1186 t "2281 1186 20 1186" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_interval(internal, "interval", int8) => "interval" */ 
DATA(insert OID = 7534 ( lag_interval  PGNSP PGUID 12 1 0 0 f f t f i 3 0 1186 t "2281 1186 20" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_interval(internal, "interval") => "interval" */ 
DATA(insert OID = 7536 ( lag_interval  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1186 t "2281 1186" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_line(internal, line, int8, line) => line */ 
DATA(insert OID = 7538 ( lag_line  PGNSP PGUID 12 1 0 0 f f t f i 4 0 628 t "2281 628 20 628" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_line(internal, line, int8) => line */ 
DATA(insert OID = 7540 ( lag_line  PGNSP PGUID 12 1 0 0 f f t f i 3 0 628 t "2281 628 20" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_line(internal, line) => line */ 
DATA(insert OID = 7542 ( lag_line  PGNSP PGUID 12 1 0 0 f f t f i 2 0 628 t "2281 628" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_lseg(internal, lseg, int8, lseg) => lseg */ 
DATA(insert OID = 7544 ( lag_lseg  PGNSP PGUID 12 1 0 0 f f t f i 4 0 601 t "2281 601 20 601" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_lseg(internal, lseg, int8) => lseg */ 
DATA(insert OID = 7546 ( lag_lseg  PGNSP PGUID 12 1 0 0 f f t f i 3 0 601 t "2281 601 20" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_lseg(internal, lseg) => lseg */ 
DATA(insert OID = 7548 ( lag_lseg  PGNSP PGUID 12 1 0 0 f f t f i 2 0 601 t "2281 601" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_macaddr(internal, macaddr, int8, macaddr) => macaddr */ 
DATA(insert OID = 7550 ( lag_macaddr  PGNSP PGUID 12 1 0 0 f f t f i 4 0 829 t "2281 829 20 829" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_macaddr(internal, macaddr, int8) => macaddr */ 
DATA(insert OID = 7552 ( lag_macaddr  PGNSP PGUID 12 1 0 0 f f t f i 3 0 829 t "2281 829 20" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_macaddr(internal, macaddr) => macaddr */ 
DATA(insert OID = 7554 ( lag_macaddr  PGNSP PGUID 12 1 0 0 f f t f i 2 0 829 t "2281 829" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_smallint(internal, int2, int8, int2) => int2 */ 
DATA(insert OID = 7556 ( lag_smallint  PGNSP PGUID 12 1 0 0 f f t f i 4 0 21 t "2281 21 20 21" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_smallint(internal, int2, int8) => int2 */ 
DATA(insert OID = 7558 ( lag_smallint  PGNSP PGUID 12 1 0 0 f f t f i 3 0 21 t "2281 21 20" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_smallint(internal, int2) => int2 */ 
DATA(insert OID = 7560 ( lag_smallint  PGNSP PGUID 12 1 0 0 f f t f i 2 0 21 t "2281 21" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_int4(internal, int4, int8, int4) => int4 */ 
DATA(insert OID = 7562 ( lag_int4  PGNSP PGUID 12 1 0 0 f f t f i 4 0 23 t "2281 23 20 23" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_int4(internal, int4, int8) => int4 */ 
DATA(insert OID = 7564 ( lag_int4  PGNSP PGUID 12 1 0 0 f f t f i 3 0 23 t "2281 23 20" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_int4(internal, int4) => int4 */ 
DATA(insert OID = 7566 ( lag_int4  PGNSP PGUID 12 1 0 0 f f t f i 2 0 23 t "2281 23" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_int8(internal, int8, int8, int8) => int8 */ 
DATA(insert OID = 7568 ( lag_int8  PGNSP PGUID 12 1 0 0 f f t f i 4 0 20 t "2281 20 20 20" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_int8(internal, int8, int8) => int8 */ 
DATA(insert OID = 7570 ( lag_int8  PGNSP PGUID 12 1 0 0 f f t f i 3 0 20 t "2281 20 20" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_int8(internal, int8) => int8 */ 
DATA(insert OID = 7572 ( lag_int8  PGNSP PGUID 12 1 0 0 f f t f i 2 0 20 t "2281 20" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_money(internal, money, int8, money) => money */ 
DATA(insert OID = 7574 ( lag_money  PGNSP PGUID 12 1 0 0 f f t f i 4 0 790 t "2281 790 20 790" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_money(internal, money, int8) => money */ 
DATA(insert OID = 7576 ( lag_money  PGNSP PGUID 12 1 0 0 f f t f i 3 0 790 t "2281 790 20" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_money(internal, money) => money */ 
DATA(insert OID = 7578 ( lag_money  PGNSP PGUID 12 1 0 0 f f t f i 2 0 790 t "2281 790" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_name(internal, name, int8, name) => name */ 
DATA(insert OID = 7580 ( lag_name  PGNSP PGUID 12 1 0 0 f f t f i 4 0 19 t "2281 19 20 19" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_name(internal, name, int8) => name */ 
DATA(insert OID = 7582 ( lag_name  PGNSP PGUID 12 1 0 0 f f t f i 3 0 19 t "2281 19 20" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_name(internal, name) => name */ 
DATA(insert OID = 7584 ( lag_name  PGNSP PGUID 12 1 0 0 f f t f i 2 0 19 t "2281 19" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_numeric(internal, "numeric", int8, "numeric") => "numeric" */ 
DATA(insert OID = 7586 ( lag_numeric  PGNSP PGUID 12 1 0 0 f f t f i 4 0 1700 t "2281 1700 20 1700" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_numeric(internal, "numeric", int8) => "numeric" */ 
DATA(insert OID = 7588 ( lag_numeric  PGNSP PGUID 12 1 0 0 f f t f i 3 0 1700 t "2281 1700 20" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_numeric(internal, "numeric") => "numeric" */ 
DATA(insert OID = 7590 ( lag_numeric  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1700 t "2281 1700" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_oid(internal, oid, int8, oid) => oid */ 
DATA(insert OID = 7592 ( lag_oid  PGNSP PGUID 12 1 0 0 f f t f i 4 0 26 t "2281 26 20 26" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_oid(internal, oid, int8) => oid */ 
DATA(insert OID = 7594 ( lag_oid  PGNSP PGUID 12 1 0 0 f f t f i 3 0 26 t "2281 26 20" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_oid(internal, oid) => oid */ 
DATA(insert OID = 7596 ( lag_oid  PGNSP PGUID 12 1 0 0 f f t f i 2 0 26 t "2281 26" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_path(internal, path, int8, path) => path */ 
DATA(insert OID = 7598 ( lag_path  PGNSP PGUID 12 1 0 0 f f t f i 4 0 602 t "2281 602 20 602" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_path(internal, path, int8) => path */ 
DATA(insert OID = 7600 ( lag_path  PGNSP PGUID 12 1 0 0 f f t f i 3 0 602 t "2281 602 20" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_path(internal, path) => path */ 
DATA(insert OID = 7602 ( lag_path  PGNSP PGUID 12 1 0 0 f f t f i 2 0 602 t "2281 602" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_point(internal, point, int8, point) => point */ 
DATA(insert OID = 7604 ( lag_point  PGNSP PGUID 12 1 0 0 f f t f i 4 0 600 t "2281 600 20 600" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_point(internal, point, int8) => point */ 
DATA(insert OID = 7606 ( lag_point  PGNSP PGUID 12 1 0 0 f f t f i 3 0 600 t "2281 600 20" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_point(internal, point) => point */ 
DATA(insert OID = 7608 ( lag_point  PGNSP PGUID 12 1 0 0 f f t f i 2 0 600 t "2281 600" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_polygon(internal, polygon, int8, polygon) => polygon */ 
DATA(insert OID = 7610 ( lag_polygon  PGNSP PGUID 12 1 0 0 f f t f i 4 0 604 t "2281 604 20 604" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_polygon(internal, polygon, int8) => polygon */ 
DATA(insert OID = 7612 ( lag_polygon  PGNSP PGUID 12 1 0 0 f f t f i 3 0 604 t "2281 604 20" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_polygon(internal, polygon) => polygon */ 
DATA(insert OID = 7614 ( lag_polygon  PGNSP PGUID 12 1 0 0 f f t f i 2 0 604 t "2281 604" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_reltime(internal, reltime, int8, reltime) => reltime */ 
DATA(insert OID = 7616 ( lag_reltime  PGNSP PGUID 12 1 0 0 f f t f i 4 0 703 t "2281 703 20 703" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_reltime(internal, reltime, int8) => reltime */ 
DATA(insert OID = 7618 ( lag_reltime  PGNSP PGUID 12 1 0 0 f f t f i 3 0 703 t "2281 703 20" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_reltime(internal, reltime) => reltime */ 
DATA(insert OID = 7620 ( lag_reltime  PGNSP PGUID 12 1 0 0 f f t f i 2 0 703 t "2281 703" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_text(internal, text, int8, text) => text */ 
DATA(insert OID = 7622 ( lag_text  PGNSP PGUID 12 1 0 0 f f t f i 4 0 25 t "2281 25 20 25" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_text(internal, text, int8) => text */ 
DATA(insert OID = 7624 ( lag_text  PGNSP PGUID 12 1 0 0 f f t f i 3 0 25 t "2281 25 20" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_text(internal, text) => text */ 
DATA(insert OID = 7626 ( lag_text  PGNSP PGUID 12 1 0 0 f f t f i 2 0 25 t "2281 25" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_tid(internal, tid, int8, tid) => tid */ 
DATA(insert OID = 7628 ( lag_tid  PGNSP PGUID 12 1 0 0 f f t f i 4 0 27 t "2281 27 20 27" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_tid(internal, tid, int8) => tid */ 
DATA(insert OID = 7630 ( lag_tid  PGNSP PGUID 12 1 0 0 f f t f i 3 0 27 t "2281 27 20" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_tid(internal, tid) => tid */ 
DATA(insert OID = 7632 ( lag_tid  PGNSP PGUID 12 1 0 0 f f t f i 2 0 27 t "2281 27" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_time(internal, "time", int8, "time") => "time" */ 
DATA(insert OID = 7634 ( lag_time  PGNSP PGUID 12 1 0 0 f f t f i 4 0 1083 t "2281 1083 20 1083" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_time(internal, "time", int8) => "time" */ 
DATA(insert OID = 7636 ( lag_time  PGNSP PGUID 12 1 0 0 f f t f i 3 0 1083 t "2281 1083 20" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_time(internal, "time") => "time" */ 
DATA(insert OID = 7638 ( lag_time  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1083 t "2281 1083" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_timestamp(internal, "timestamp", int8, "timestamp") => "timestamp" */ 
DATA(insert OID = 7640 ( lag_timestamp  PGNSP PGUID 12 1 0 0 f f t f i 4 0 1114 t "2281 1114 20 1114" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_timestamp(internal, "timestamp", int8) => "timestamp" */ 
DATA(insert OID = 7642 ( lag_timestamp  PGNSP PGUID 12 1 0 0 f f t f i 3 0 1114 t "2281 1114 20" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_timestamp(internal, "timestamp") => "timestamp" */ 
DATA(insert OID = 7644 ( lag_timestamp  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1114 t "2281 1114" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_timestamptz(internal, timestamptz, int8, timestamptz) => timestamptz */ 
DATA(insert OID = 7646 ( lag_timestamptz  PGNSP PGUID 12 1 0 0 f f t f i 4 0 1184 t "2281 1184 20 1184" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_timestamptz(internal, timestamptz, int8) => timestamptz */ 
DATA(insert OID = 7648 ( lag_timestamptz  PGNSP PGUID 12 1 0 0 f f t f i 3 0 1184 t "2281 1184 20" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_timestamptz(internal, timestamptz) => timestamptz */ 
DATA(insert OID = 7650 ( lag_timestamptz  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1184 t "2281 1184" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_timetz(internal, timetz, int8, timetz) => timetz */ 
DATA(insert OID = 7652 ( lag_timetz  PGNSP PGUID 12 1 0 0 f f t f i 4 0 1266 t "2281 1266 20 1266" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_timetz(internal, timetz, int8) => timetz */ 
DATA(insert OID = 7654 ( lag_timetz  PGNSP PGUID 12 1 0 0 f f t f i 3 0 1266 t "2281 1266 20" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_timetz(internal, timetz) => timetz */ 
DATA(insert OID = 7656 ( lag_timetz  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1266 t "2281 1266" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_varbit(internal, varbit, int8, varbit) => varbit */ 
DATA(insert OID = 7658 ( lag_varbit  PGNSP PGUID 12 1 0 0 f f t f i 4 0 1562 t "2281 1562 20 1562" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_varbit(internal, varbit, int8) => varbit */ 
DATA(insert OID = 7660 ( lag_varbit  PGNSP PGUID 12 1 0 0 f f t f i 3 0 1562 t "2281 1562 20" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_varbit(internal, varbit) => varbit */ 
DATA(insert OID = 7662 ( lag_varbit  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1562 t "2281 1562" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_varchar(internal, "varchar", int8, "varchar") => "varchar" */ 
DATA(insert OID = 7664 ( lag_varchar  PGNSP PGUID 12 1 0 0 f f t f i 4 0 1043 t "2281 1043 20 1043" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_varchar(internal, "varchar", int8) => "varchar" */ 
DATA(insert OID = 7666 ( lag_varchar  PGNSP PGUID 12 1 0 0 f f t f i 3 0 1043 t "2281 1043 20" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_varchar(internal, "varchar") => "varchar" */ 
DATA(insert OID = 7668 ( lag_varchar  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1043 t "2281 1043" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_xid(internal, xid, int8, xid) => xid */ 
DATA(insert OID = 7670 ( lag_xid  PGNSP PGUID 12 1 0 0 f f t f i 4 0 28 t "2281 28 20 28" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_xid(internal, xid, int8) => xid */ 
DATA(insert OID = 7672 ( lag_xid  PGNSP PGUID 12 1 0 0 f f t f i 3 0 28 t "2281 28 20" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_xid(internal, xid) => xid */ 
DATA(insert OID = 7674 ( lag_xid  PGNSP PGUID 12 1 0 0 f f t f i 2 0 28 t "2281 28" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_any(internal, anyarray, int8, anyarray) => anyarray */ 
DATA(insert OID = 7208 ( lag_any  PGNSP PGUID 12 1 0 0 f f t f i 4 0 2277 t "2281 2277 20 2277" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_any(internal, anyarray, int8) => anyarray */ 
DATA(insert OID = 7209 ( lag_any  PGNSP PGUID 12 1 0 0 f f t f i 3 0 2277 t "2281 2277 20" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_any(internal, anyarray) => anyarray */ 
DATA(insert OID = 7210 ( lag_any  PGNSP PGUID 12 1 0 0 f f t f i 2 0 2277 t "2281 2277" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_bytea(internal, bytea) => bytea */ 
DATA(insert OID = 7227 ( lag_bytea  PGNSP PGUID 12 1 0 0 f f t f i 2 0 17 t "2281 17" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_bytea(internal, bytea, int8) => bytea */ 
DATA(insert OID = 7229 ( lag_bytea  PGNSP PGUID 12 1 0 0 f f t f i 3 0 17 t "2281 17 20" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_bytea(internal, bytea, int8, bytea) => bytea */ 
DATA(insert OID = 7231 ( lag_bytea  PGNSP PGUID 12 1 0 0 f f t f i 4 0 17 t "2281 17 20 17" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_bit(internal, "bit") => "bit" */ 
DATA(insert OID = 7251 ( lag_bit  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1560 t "2281 1560" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_bit(internal, "bit", int8) => "bit" */ 
DATA(insert OID = 7253 ( lag_bit  PGNSP PGUID 12 1 0 0 f f t f i 3 0 1560 t "2281 1560 20" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_bit(internal, "bit", int8, "bit") => "bit" */ 
DATA(insert OID = 7255 ( lag_bit  PGNSP PGUID 12 1 0 0 f f t f i 4 0 1560 t "2281 1560 20 1560" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_box(internal, box) => box */ 
DATA(insert OID = 7267 ( lag_box  PGNSP PGUID 12 1 0 0 f f t f i 2 0 603 t "2281 603" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_box(internal, box, int8) => box */ 
DATA(insert OID = 7269 ( lag_box  PGNSP PGUID 12 1 0 0 f f t f i 3 0 603 t "2281 603 20" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lag_box(internal, box, int8, box) => box */ 
DATA(insert OID = 7271 ( lag_box  PGNSP PGUID 12 1 0 0 f f t f i 4 0 603 t "2281 603 20 603" _null_ _null_ _null_ _null_ lag_generic _null_ _null_ _null_ n ));

/* lead_int(internal, int4, int8, int4) => int4 */ 
DATA(insert OID = 7106 ( lead_int  PGNSP PGUID 12 1 0 0 f f t f i 4 0 23 t "2281 23 20 23" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_int(internal, int4, int8) => int4 */ 
DATA(insert OID = 7104 ( lead_int  PGNSP PGUID 12 1 0 0 f f t f i 3 0 23 t "2281 23 20" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_int(internal, int4) => int4 */ 
DATA(insert OID = 7105 ( lead_int  PGNSP PGUID 12 1 0 0 f f t f i 2 0 23 t "2281 23" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_bool(internal, bool, int8, bool) => bool */ 
DATA(insert OID = 7311 ( lead_bool  PGNSP PGUID 12 1 0 0 f f t f i 4 0 16 t "2281 16 20 16" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_bool(internal, bool, int8) => bool */ 
DATA(insert OID = 7313 ( lead_bool  PGNSP PGUID 12 1 0 0 f f t f i 3 0 16 t "2281 16 20" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_bool(internal, bool) => bool */ 
DATA(insert OID = 7315 ( lead_bool  PGNSP PGUID 12 1 0 0 f f t f i 2 0 16 t "2281 16" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_char(internal, "char", int8, "char") => "char" */ 
DATA(insert OID = 7317 ( lead_char  PGNSP PGUID 12 1 0 0 f f t f i 4 0 18 t "2281 18 20 18" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_char(internal, "char", int8) => "char" */ 
DATA(insert OID = 7319 ( lead_char  PGNSP PGUID 12 1 0 0 f f t f i 3 0 18 t "2281 18 20" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_char(internal, "char") => "char" */ 
DATA(insert OID = 7321 ( lead_char  PGNSP PGUID 12 1 0 0 f f t f i 2 0 18 t "2281 18" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_cidr(internal, cidr, int8, cidr) => cidr */ 
DATA(insert OID = 7323 ( lead_cidr  PGNSP PGUID 12 1 0 0 f f t f i 4 0 650 t "2281 650 20 650" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_cidr(internal, cidr, int8) => cidr */ 
DATA(insert OID = 7325 ( lead_cidr  PGNSP PGUID 12 1 0 0 f f t f i 3 0 650 t "2281 650 20" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_cidr(internal, cidr) => cidr */ 
DATA(insert OID = 7327 ( lead_cidr  PGNSP PGUID 12 1 0 0 f f t f i 2 0 650 t "2281 650" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_circle(internal, circle, int8, circle) => circle */ 
DATA(insert OID = 7329 ( lead_circle  PGNSP PGUID 12 1 0 0 f f t f i 4 0 718 t "2281 718 20 718" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_circle(internal, circle, int8) => circle */ 
DATA(insert OID = 7331 ( lead_circle  PGNSP PGUID 12 1 0 0 f f t f i 3 0 718 t "2281 718 20" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_circle(internal, circle) => circle */ 
DATA(insert OID = 7333 ( lead_circle  PGNSP PGUID 12 1 0 0 f f t f i 2 0 718 t "2281 718" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_float4(internal, float4, int8, float4) => float4 */ 
DATA(insert OID = 7335 ( lead_float4  PGNSP PGUID 12 1 0 0 f f t f i 4 0 700 t "2281 700 20 700" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_float4(internal, float4, int8) => float4 */ 
DATA(insert OID = 7337 ( lead_float4  PGNSP PGUID 12 1 0 0 f f t f i 3 0 700 t "2281 700 20" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_float4(internal, float4) => float4 */ 
DATA(insert OID = 7339 ( lead_float4  PGNSP PGUID 12 1 0 0 f f t f i 2 0 700 t "2281 700" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_float8(internal, float8, int8, float8) => float8 */ 
DATA(insert OID = 7341 ( lead_float8  PGNSP PGUID 12 1 0 0 f f t f i 4 0 701 t "2281 701 20 701" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_float8(internal, float8, int8) => float8 */ 
DATA(insert OID = 7343 ( lead_float8  PGNSP PGUID 12 1 0 0 f f t f i 3 0 701 t "2281 701 20" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_float8(internal, float8) => float8 */ 
DATA(insert OID = 7345 ( lead_float8  PGNSP PGUID 12 1 0 0 f f t f i 2 0 701 t "2281 701" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_inet(internal, inet, int8, inet) => inet */ 
DATA(insert OID = 7347 ( lead_inet  PGNSP PGUID 12 1 0 0 f f t f i 4 0 869 t "2281 869 20 869" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_inet(internal, inet, int8) => inet */ 
DATA(insert OID = 7349 ( lead_inet  PGNSP PGUID 12 1 0 0 f f t f i 3 0 869 t "2281 869 20" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_inet(internal, inet) => inet */ 
DATA(insert OID = 7351 ( lead_inet  PGNSP PGUID 12 1 0 0 f f t f i 2 0 869 t "2281 869" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_interval(internal, "interval", int8, "interval") => "interval" */ 
DATA(insert OID = 7353 ( lead_interval  PGNSP PGUID 12 1 0 0 f f t f i 4 0 1186 t "2281 1186 20 1186" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_interval(internal, "interval", int8) => "interval" */ 
DATA(insert OID = 7355 ( lead_interval  PGNSP PGUID 12 1 0 0 f f t f i 3 0 1186 t "2281 1186 20" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_interval(internal, "interval") => "interval" */ 
DATA(insert OID = 7357 ( lead_interval  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1186 t "2281 1186" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_line(internal, line, int8, line) => line */ 
DATA(insert OID = 7359 ( lead_line  PGNSP PGUID 12 1 0 0 f f t f i 4 0 628 t "2281 628 20 628" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_line(internal, line, int8) => line */ 
DATA(insert OID = 7361 ( lead_line  PGNSP PGUID 12 1 0 0 f f t f i 3 0 628 t "2281 628 20" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_line(internal, line) => line */ 
DATA(insert OID = 7363 ( lead_line  PGNSP PGUID 12 1 0 0 f f t f i 2 0 628 t "2281 628" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_lseg(internal, lseg, int8, lseg) => lseg */ 
DATA(insert OID = 7365 ( lead_lseg  PGNSP PGUID 12 1 0 0 f f t f i 4 0 601 t "2281 601 20 601" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_lseg(internal, lseg, int8) => lseg */ 
DATA(insert OID = 7367 ( lead_lseg  PGNSP PGUID 12 1 0 0 f f t f i 3 0 601 t "2281 601 20" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_lseg(internal, lseg) => lseg */ 
DATA(insert OID = 7369 ( lead_lseg  PGNSP PGUID 12 1 0 0 f f t f i 2 0 601 t "2281 601" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_macaddr(internal, macaddr, int8, macaddr) => macaddr */ 
DATA(insert OID = 7371 ( lead_macaddr  PGNSP PGUID 12 1 0 0 f f t f i 4 0 829 t "2281 829 20 829" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_macaddr(internal, macaddr, int8) => macaddr */ 
DATA(insert OID = 7373 ( lead_macaddr  PGNSP PGUID 12 1 0 0 f f t f i 3 0 829 t "2281 829 20" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_macaddr(internal, macaddr) => macaddr */ 
DATA(insert OID = 7375 ( lead_macaddr  PGNSP PGUID 12 1 0 0 f f t f i 2 0 829 t "2281 829" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_smallint(internal, int2, int8, int2) => int2 */ 
DATA(insert OID = 7377 ( lead_smallint  PGNSP PGUID 12 1 0 0 f f t f i 4 0 21 t "2281 21 20 21" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_smallint(internal, int2, int8) => int2 */ 
DATA(insert OID = 7379 ( lead_smallint  PGNSP PGUID 12 1 0 0 f f t f i 3 0 21 t "2281 21 20" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_smallint(internal, int2) => int2 */ 
DATA(insert OID = 7381 ( lead_smallint  PGNSP PGUID 12 1 0 0 f f t f i 2 0 21 t "2281 21" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_int8(internal, int8, int8, int8) => int8 */ 
DATA(insert OID = 7383 ( lead_int8  PGNSP PGUID 12 1 0 0 f f t f i 4 0 20 t "2281 20 20 20" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_int8(internal, int8, int8) => int8 */ 
DATA(insert OID = 7385 ( lead_int8  PGNSP PGUID 12 1 0 0 f f t f i 3 0 20 t "2281 20 20" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_int8(internal, int8) => int8 */ 
DATA(insert OID = 7387 ( lead_int8  PGNSP PGUID 12 1 0 0 f f t f i 2 0 20 t "2281 20" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_money(internal, money, int8, money) => money */ 
DATA(insert OID = 7389 ( lead_money  PGNSP PGUID 12 1 0 0 f f t f i 4 0 790 t "2281 790 20 790" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_money(internal, money, int8) => money */ 
DATA(insert OID = 7391 ( lead_money  PGNSP PGUID 12 1 0 0 f f t f i 3 0 790 t "2281 790 20" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_money(internal, money) => money */ 
DATA(insert OID = 7393 ( lead_money  PGNSP PGUID 12 1 0 0 f f t f i 2 0 790 t "2281 790" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_name(internal, name, int8, name) => name */ 
DATA(insert OID = 7395 ( lead_name  PGNSP PGUID 12 1 0 0 f f t f i 4 0 19 t "2281 19 20 19" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_name(internal, name, int8) => name */ 
DATA(insert OID = 7397 ( lead_name  PGNSP PGUID 12 1 0 0 f f t f i 3 0 19 t "2281 19 20" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_name(internal, name) => name */ 
DATA(insert OID = 7399 ( lead_name  PGNSP PGUID 12 1 0 0 f f t f i 2 0 19 t "2281 19" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_numeric(internal, "numeric", int8, "numeric") => "numeric" */ 
DATA(insert OID = 7401 ( lead_numeric  PGNSP PGUID 12 1 0 0 f f t f i 4 0 1700 t "2281 1700 20 1700" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_numeric(internal, "numeric", int8) => "numeric" */ 
DATA(insert OID = 7403 ( lead_numeric  PGNSP PGUID 12 1 0 0 f f t f i 3 0 1700 t "2281 1700 20" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_numeric(internal, "numeric") => "numeric" */ 
DATA(insert OID = 7405 ( lead_numeric  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1700 t "2281 1700" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_oid(internal, oid, int8, oid) => oid */ 
DATA(insert OID = 7407 ( lead_oid  PGNSP PGUID 12 1 0 0 f f t f i 4 0 26 t "2281 26 20 26" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_oid(internal, oid, int8) => oid */ 
DATA(insert OID = 7409 ( lead_oid  PGNSP PGUID 12 1 0 0 f f t f i 3 0 26 t "2281 26 20" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_oid(internal, oid) => oid */ 
DATA(insert OID = 7411 ( lead_oid  PGNSP PGUID 12 1 0 0 f f t f i 2 0 26 t "2281 26" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_path(internal, path, int8, path) => path */ 
DATA(insert OID = 7413 ( lead_path  PGNSP PGUID 12 1 0 0 f f t f i 4 0 602 t "2281 602 20 602" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_path(internal, path, int8) => path */ 
DATA(insert OID = 7415 ( lead_path  PGNSP PGUID 12 1 0 0 f f t f i 3 0 602 t "2281 602 20" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_path(internal, path) => path */ 
DATA(insert OID = 7417 ( lead_path  PGNSP PGUID 12 1 0 0 f f t f i 2 0 602 t "2281 602" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_point(internal, point, int8, point) => point */ 
DATA(insert OID = 7419 ( lead_point  PGNSP PGUID 12 1 0 0 f f t f i 4 0 600 t "2281 600 20 600" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_point(internal, point, int8) => point */ 
DATA(insert OID = 7421 ( lead_point  PGNSP PGUID 12 1 0 0 f f t f i 3 0 600 t "2281 600 20" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_point(internal, point) => point */ 
DATA(insert OID = 7423 ( lead_point  PGNSP PGUID 12 1 0 0 f f t f i 2 0 600 t "2281 600" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_polygon(internal, polygon, int8, polygon) => polygon */ 
DATA(insert OID = 7425 ( lead_polygon  PGNSP PGUID 12 1 0 0 f f t f i 4 0 604 t "2281 604 20 604" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_polygon(internal, polygon, int8) => polygon */ 
DATA(insert OID = 7427 ( lead_polygon  PGNSP PGUID 12 1 0 0 f f t f i 3 0 604 t "2281 604 20" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_polygon(internal, polygon) => polygon */ 
DATA(insert OID = 7429 ( lead_polygon  PGNSP PGUID 12 1 0 0 f f t f i 2 0 604 t "2281 604" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_reltime(internal, reltime, int8, reltime) => reltime */ 
DATA(insert OID = 7431 ( lead_reltime  PGNSP PGUID 12 1 0 0 f f t f i 4 0 703 t "2281 703 20 703" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_reltime(internal, reltime, int8) => reltime */ 
DATA(insert OID = 7433 ( lead_reltime  PGNSP PGUID 12 1 0 0 f f t f i 3 0 703 t "2281 703 20" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_reltime(internal, reltime) => reltime */ 
DATA(insert OID = 7435 ( lead_reltime  PGNSP PGUID 12 1 0 0 f f t f i 2 0 703 t "2281 703" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_text(internal, text, int8, text) => text */ 
DATA(insert OID = 7437 ( lead_text  PGNSP PGUID 12 1 0 0 f f t f i 4 0 25 t "2281 25 20 25" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_text(internal, text, int8) => text */ 
DATA(insert OID = 7439 ( lead_text  PGNSP PGUID 12 1 0 0 f f t f i 3 0 25 t "2281 25 20" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_text(internal, text) => text */ 
DATA(insert OID = 7441 ( lead_text  PGNSP PGUID 12 1 0 0 f f t f i 2 0 25 t "2281 25" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_tid(internal, tid, int8, tid) => tid */ 
DATA(insert OID = 7443 ( lead_tid  PGNSP PGUID 12 1 0 0 f f t f i 4 0 27 t "2281 27 20 27" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_tid(internal, tid, int8) => tid */ 
DATA(insert OID = 7445 ( lead_tid  PGNSP PGUID 12 1 0 0 f f t f i 3 0 27 t "2281 27 20" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_tid(internal, tid) => tid */ 
DATA(insert OID = 7447 ( lead_tid  PGNSP PGUID 12 1 0 0 f f t f i 2 0 27 t "2281 27" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_time(internal, "time", int8, "time") => "time" */ 
DATA(insert OID = 7449 ( lead_time  PGNSP PGUID 12 1 0 0 f f t f i 4 0 1083 t "2281 1083 20 1083" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_time(internal, "time", int8) => "time" */ 
DATA(insert OID = 7451 ( lead_time  PGNSP PGUID 12 1 0 0 f f t f i 3 0 1083 t "2281 1083 20" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_time(internal, "time") => "time" */ 
DATA(insert OID = 7453 ( lead_time  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1083 t "2281 1083" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_timestamp(internal, "timestamp", int8, "timestamp") => "timestamp" */ 
DATA(insert OID = 7455 ( lead_timestamp  PGNSP PGUID 12 1 0 0 f f t f i 4 0 1114 t "2281 1114 20 1114" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_timestamp(internal, "timestamp", int8) => "timestamp" */ 
DATA(insert OID = 7457 ( lead_timestamp  PGNSP PGUID 12 1 0 0 f f t f i 3 0 1114 t "2281 1114 20" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_timestamp(internal, "timestamp") => "timestamp" */ 
DATA(insert OID = 7459 ( lead_timestamp  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1114 t "2281 1114" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_timestamptz(internal, timestamptz, int8, timestamptz) => timestamptz */ 
DATA(insert OID = 7461 ( lead_timestamptz  PGNSP PGUID 12 1 0 0 f f t f i 4 0 1184 t "2281 1184 20 1184" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_timestamptz(internal, timestamptz, int8) => timestamptz */ 
DATA(insert OID = 7463 ( lead_timestamptz  PGNSP PGUID 12 1 0 0 f f t f i 3 0 1184 t "2281 1184 20" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_timestamptz(internal, timestamptz) => timestamptz */ 
DATA(insert OID = 7465 ( lead_timestamptz  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1184 t "2281 1184" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_timetz(internal, timetz, int8, timetz) => timetz */ 
DATA(insert OID = 7467 ( lead_timetz  PGNSP PGUID 12 1 0 0 f f t f i 4 0 1266 t "2281 1266 20 1266" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_timetz(internal, timetz, int8) => timetz */ 
DATA(insert OID = 7469 ( lead_timetz  PGNSP PGUID 12 1 0 0 f f t f i 3 0 1266 t "2281 1266 20" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_timetz(internal, timetz) => timetz */ 
DATA(insert OID = 7471 ( lead_timetz  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1266 t "2281 1266" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_varbit(internal, varbit, int8, varbit) => varbit */ 
DATA(insert OID = 7473 ( lead_varbit  PGNSP PGUID 12 1 0 0 f f t f i 4 0 1562 t "2281 1562 20 1562" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_varbit(internal, varbit, int8) => varbit */ 
DATA(insert OID = 7475 ( lead_varbit  PGNSP PGUID 12 1 0 0 f f t f i 3 0 1562 t "2281 1562 20" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_varbit(internal, varbit) => varbit */ 
DATA(insert OID = 7477 ( lead_varbit  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1562 t "2281 1562" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_varchar(internal, "varchar", int8, "varchar") => "varchar" */ 
DATA(insert OID = 7479 ( lead_varchar  PGNSP PGUID 12 1 0 0 f f t f i 4 0 1043 t "2281 1043 20 1043" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_varchar(internal, "varchar", int8) => "varchar" */ 
DATA(insert OID = 7481 ( lead_varchar  PGNSP PGUID 12 1 0 0 f f t f i 3 0 1043 t "2281 1043 20" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_varchar(internal, "varchar") => "varchar" */ 
DATA(insert OID = 7483 ( lead_varchar  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1043 t "2281 1043" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_xid(internal, xid, int8, xid) => xid */ 
DATA(insert OID = 7485 ( lead_xid  PGNSP PGUID 12 1 0 0 f f t f i 4 0 28 t "2281 28 20 28" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_xid(internal, xid, int8) => xid */ 
DATA(insert OID = 7487 ( lead_xid  PGNSP PGUID 12 1 0 0 f f t f i 3 0 28 t "2281 28 20" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_xid(internal, xid) => xid */ 
DATA(insert OID = 7489 ( lead_xid  PGNSP PGUID 12 1 0 0 f f t f i 2 0 28 t "2281 28" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_any(internal, anyarray, int8, anyarray) => anyarray */ 
DATA(insert OID = 7217 ( lead_any  PGNSP PGUID 12 1 0 0 f f t f i 4 0 2277 t "2281 2277 20 2277" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_any(internal, anyarray, int8) => anyarray */ 
DATA(insert OID = 7218 ( lead_any  PGNSP PGUID 12 1 0 0 f f t f i 3 0 2277 t "2281 2277 20" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_any(internal, anyarray) => anyarray */ 
DATA(insert OID = 7219 ( lead_any  PGNSP PGUID 12 1 0 0 f f t f i 2 0 2277 t "2281 2277" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_bytea(internal, bytea) => bytea */ 
DATA(insert OID = 7221 ( lead_bytea  PGNSP PGUID 12 1 0 0 f f t f i 2 0 17 t "2281 17" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_bytea(internal, bytea, int8) => bytea */ 
DATA(insert OID = 7223 ( lead_bytea  PGNSP PGUID 12 1 0 0 f f t f i 3 0 17 t "2281 17 20" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_bytea(internal, bytea, int8, bytea) => bytea */ 
DATA(insert OID = 7225 ( lead_bytea  PGNSP PGUID 12 1 0 0 f f t f i 4 0 17 t "2281 17 20 17" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_bit(internal, "bit") => "bit" */ 
DATA(insert OID = 7245 ( lead_bit  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1560 t "2281 1560" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_bit(internal, "bit", int8) => "bit" */ 
DATA(insert OID = 7247 ( lead_bit  PGNSP PGUID 12 1 0 0 f f t f i 3 0 1560 t "2281 1560 20" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_bit(internal, "bit", int8, "bit") => "bit" */ 
DATA(insert OID = 7249 ( lead_bit  PGNSP PGUID 12 1 0 0 f f t f i 4 0 1560 t "2281 1560 20 1560" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_box(internal, box) => box */ 
DATA(insert OID = 7261 ( lead_box  PGNSP PGUID 12 1 0 0 f f t f i 2 0 603 t "2281 603" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_box(internal, box, int8) => box */ 
DATA(insert OID = 7263 ( lead_box  PGNSP PGUID 12 1 0 0 f f t f i 3 0 603 t "2281 603 20" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* lead_box(internal, box, int8, box) => box */ 
DATA(insert OID = 7265 ( lead_box  PGNSP PGUID 12 1 0 0 f f t f i 4 0 603 t "2281 603 20 603" _null_ _null_ _null_ _null_ lead_generic _null_ _null_ _null_ n ));

/* first_value_bool(internal, bool) => bool */ 
DATA(insert OID = 7111 ( first_value_bool  PGNSP PGUID 12 1 0 0 f f t f i 2 0 16 t "2281 16" _null_ _null_ _null_ _null_ first_value_generic _null_ _null_ _null_ n ));

/* first_value_char(internal, "char") => "char" */ 
DATA(insert OID = 7112 ( first_value_char  PGNSP PGUID 12 1 0 0 f f t f i 2 0 18 t "2281 18" _null_ _null_ _null_ _null_ first_value_generic _null_ _null_ _null_ n ));

/* first_value_cidr(internal, cidr) => cidr */ 
DATA(insert OID = 7113 ( first_value_cidr  PGNSP PGUID 12 1 0 0 f f t f i 2 0 650 t "2281 650" _null_ _null_ _null_ _null_ first_value_generic _null_ _null_ _null_ n ));

/* first_value_circle(internal, circle) => circle */ 
DATA(insert OID = 7114 ( first_value_circle  PGNSP PGUID 12 1 0 0 f f t f i 2 0 718 t "2281 718" _null_ _null_ _null_ _null_ first_value_generic _null_ _null_ _null_ n ));

/* first_value_float4(internal, float4) => float4 */ 
DATA(insert OID = 7115 ( first_value_float4  PGNSP PGUID 12 1 0 0 f f t f i 2 0 700 t "2281 700" _null_ _null_ _null_ _null_ first_value_generic _null_ _null_ _null_ n ));

/* first_value_float8(internal, float8) => float8 */ 
DATA(insert OID = 7116 ( first_value_float8  PGNSP PGUID 12 1 0 0 f f t f i 2 0 701 t "2281 701" _null_ _null_ _null_ _null_ first_value_generic _null_ _null_ _null_ n ));

/* first_value_inet(internal, inet) => inet */ 
DATA(insert OID = 7117 ( first_value_inet  PGNSP PGUID 12 1 0 0 f f t f i 2 0 869 t "2281 869" _null_ _null_ _null_ _null_ first_value_generic _null_ _null_ _null_ n ));

/* first_value_interval(internal, "interval") => "interval" */ 
DATA(insert OID = 7118 ( first_value_interval  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1186 t "2281 1186" _null_ _null_ _null_ _null_ first_value_generic _null_ _null_ _null_ n ));

/* first_value_line(internal, line) => line */ 
DATA(insert OID = 7119 ( first_value_line  PGNSP PGUID 12 1 0 0 f f t f i 2 0 628 t "2281 628" _null_ _null_ _null_ _null_ first_value_generic _null_ _null_ _null_ n ));

/* first_value_lseg(internal, lseg) => lseg */ 
DATA(insert OID = 7120 ( first_value_lseg  PGNSP PGUID 12 1 0 0 f f t f i 2 0 601 t "2281 601" _null_ _null_ _null_ _null_ first_value_generic _null_ _null_ _null_ n ));

/* first_value_macaddr(internal, macaddr) => macaddr */ 
DATA(insert OID = 7121 ( first_value_macaddr  PGNSP PGUID 12 1 0 0 f f t f i 2 0 829 t "2281 829" _null_ _null_ _null_ _null_ first_value_generic _null_ _null_ _null_ n ));

/* first_value_smallint(internal, int2) => int2 */ 
DATA(insert OID = 7122 ( first_value_smallint  PGNSP PGUID 12 1 0 0 f f t f i 2 0 21 t "2281 21" _null_ _null_ _null_ _null_ first_value_generic _null_ _null_ _null_ n ));

/* first_value_int4(internal, int4) => int4 */ 
DATA(insert OID = 7123 ( first_value_int4  PGNSP PGUID 12 1 0 0 f f t f i 2 0 23 t "2281 23" _null_ _null_ _null_ _null_ first_value_generic _null_ _null_ _null_ n ));

/* first_value_int8(internal, int8) => int8 */ 
DATA(insert OID = 7124 ( first_value_int8  PGNSP PGUID 12 1 0 0 f f t f i 2 0 20 t "2281 20" _null_ _null_ _null_ _null_ first_value_generic _null_ _null_ _null_ n ));

/* first_value_money(internal, money) => money */ 
DATA(insert OID = 7125 ( first_value_money  PGNSP PGUID 12 1 0 0 f f t f i 2 0 790 t "2281 790" _null_ _null_ _null_ _null_ first_value_generic _null_ _null_ _null_ n ));

/* first_value_name(internal, name) => name */ 
DATA(insert OID = 7126 ( first_value_name  PGNSP PGUID 12 1 0 0 f f t f i 2 0 19 t "2281 19" _null_ _null_ _null_ _null_ first_value_generic _null_ _null_ _null_ n ));

/* first_value_numeric(internal, "numeric") => "numeric" */ 
DATA(insert OID = 7127 ( first_value_numeric  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1700 t "2281 1700" _null_ _null_ _null_ _null_ first_value_generic _null_ _null_ _null_ n ));

/* first_value_oid(internal, oid) => oid */ 
DATA(insert OID = 7128 ( first_value_oid  PGNSP PGUID 12 1 0 0 f f t f i 2 0 26 t "2281 26" _null_ _null_ _null_ _null_ first_value_generic _null_ _null_ _null_ n ));

/* first_value_path(internal, path) => path */ 
DATA(insert OID = 7129 ( first_value_path  PGNSP PGUID 12 1 0 0 f f t f i 2 0 602 t "2281 602" _null_ _null_ _null_ _null_ first_value_generic _null_ _null_ _null_ n ));

/* first_value_point(internal, point) => point */ 
DATA(insert OID = 7130 ( first_value_point  PGNSP PGUID 12 1 0 0 f f t f i 2 0 600 t "2281 600" _null_ _null_ _null_ _null_ first_value_generic _null_ _null_ _null_ n ));

/* first_value_polygon(internal, polygon) => polygon */ 
DATA(insert OID = 7131 ( first_value_polygon  PGNSP PGUID 12 1 0 0 f f t f i 2 0 604 t "2281 604" _null_ _null_ _null_ _null_ first_value_generic _null_ _null_ _null_ n ));

/* first_value_reltime(internal, reltime) => reltime */ 
DATA(insert OID = 7132 ( first_value_reltime  PGNSP PGUID 12 1 0 0 f f t f i 2 0 703 t "2281 703" _null_ _null_ _null_ _null_ first_value_generic _null_ _null_ _null_ n ));

/* first_value_text(internal, text) => text */ 
DATA(insert OID = 7133 ( first_value_text  PGNSP PGUID 12 1 0 0 f f t f i 2 0 25 t "2281 25" _null_ _null_ _null_ _null_ first_value_generic _null_ _null_ _null_ n ));

/* first_value_tid(internal, tid) => tid */ 
DATA(insert OID = 7134 ( first_value_tid  PGNSP PGUID 12 1 0 0 f f t f i 2 0 27 t "2281 27" _null_ _null_ _null_ _null_ first_value_generic _null_ _null_ _null_ n ));

/* first_value_time(internal, "time") => "time" */ 
DATA(insert OID = 7135 ( first_value_time  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1083 t "2281 1083" _null_ _null_ _null_ _null_ first_value_generic _null_ _null_ _null_ n ));

/* first_value_timestamp(internal, "timestamp") => "timestamp" */ 
DATA(insert OID = 7136 ( first_value_timestamp  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1114 t "2281 1114" _null_ _null_ _null_ _null_ first_value_generic _null_ _null_ _null_ n ));

/* first_value_timestamptz(internal, timestamptz) => timestamptz */ 
DATA(insert OID = 7137 ( first_value_timestamptz  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1184 t "2281 1184" _null_ _null_ _null_ _null_ first_value_generic _null_ _null_ _null_ n ));

/* first_value_timetz(internal, timetz) => timetz */ 
DATA(insert OID = 7138 ( first_value_timetz  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1266 t "2281 1266" _null_ _null_ _null_ _null_ first_value_generic _null_ _null_ _null_ n ));

/* first_value_varbit(internal, varbit) => varbit */ 
DATA(insert OID = 7139 ( first_value_varbit  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1562 t "2281 1562" _null_ _null_ _null_ _null_ first_value_generic _null_ _null_ _null_ n ));

/* first_value_varchar(internal, "varchar") => "varchar" */ 
DATA(insert OID = 7140 ( first_value_varchar  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1043 t "2281 1043" _null_ _null_ _null_ _null_ first_value_generic _null_ _null_ _null_ n ));

/* first_value_xid(internal, xid) => xid */ 
DATA(insert OID = 7141 ( first_value_xid  PGNSP PGUID 12 1 0 0 f f t f i 2 0 28 t "2281 28" _null_ _null_ _null_ _null_ first_value_generic _null_ _null_ _null_ n ));

/* first_value_bytea(internal, bytea) => bytea */ 
DATA(insert OID = 7233 ( first_value_bytea  PGNSP PGUID 12 1 0 0 f f t f i 2 0 17 t "2281 17" _null_ _null_ _null_ _null_ first_value_generic _null_ _null_ _null_ n ));

/* first_value_bit(internal, "bit") => "bit" */ 
DATA(insert OID = 7257 ( first_value_bit  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1560 t "2281 1560" _null_ _null_ _null_ _null_ first_value_generic _null_ _null_ _null_ n ));

/* first_value_box(internal, box) => box */ 
DATA(insert OID = 7273 ( first_value_box  PGNSP PGUID 12 1 0 0 f f t f i 2 0 603 t "2281 603" _null_ _null_ _null_ _null_ first_value_generic _null_ _null_ _null_ n ));

/* first_value_any(internal, anyarray) => anyarray */ 
DATA(insert OID = 7289 ( first_value_any  PGNSP PGUID 12 1 0 0 f f t f i 2 0 2277 t "2281 2277" _null_ _null_ _null_ _null_ first_value_generic _null_ _null_ _null_ n ));

/* last_value_int(internal, int4) => int4 */ 
DATA(insert OID = 7103 ( last_value_int  PGNSP PGUID 12 1 0 0 f f t f i 2 0 23 t "2281 23" _null_ _null_ _null_ _null_ last_value_generic _null_ _null_ _null_ n ));

/* last_value_smallint(internal, int2) => int2 */ 
DATA(insert OID = 7107 ( last_value_smallint  PGNSP PGUID 12 1 0 0 f f t f i 2 0 21 t "2281 21" _null_ _null_ _null_ _null_ last_value_generic _null_ _null_ _null_ n ));

/* last_value_bigint(internal, int8) => int8 */ 
DATA(insert OID = 7108 ( last_value_bigint  PGNSP PGUID 12 1 0 0 f f t f i 2 0 20 t "2281 20" _null_ _null_ _null_ _null_ last_value_generic _null_ _null_ _null_ n ));

/* last_value_numeric(internal, "numeric") => "numeric" */ 
DATA(insert OID = 7109 ( last_value_numeric  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1700 t "2281 1700" _null_ _null_ _null_ _null_ last_value_generic _null_ _null_ _null_ n ));

/* last_value_text(internal, text) => text */ 
DATA(insert OID = 7110 ( last_value_text  PGNSP PGUID 12 1 0 0 f f t f i 2 0 25 t "2281 25" _null_ _null_ _null_ _null_ last_value_generic _null_ _null_ _null_ n ));

/* last_value_bool(internal, bool) => bool */ 
DATA(insert OID = 7165 ( last_value_bool  PGNSP PGUID 12 1 0 0 f f t f i 2 0 16 t "2281 16" _null_ _null_ _null_ _null_ last_value_generic _null_ _null_ _null_ n ));

/* last_value_char(internal, "char") => "char" */ 
DATA(insert OID = 7166 ( last_value_char  PGNSP PGUID 12 1 0 0 f f t f i 2 0 18 t "2281 18" _null_ _null_ _null_ _null_ last_value_generic _null_ _null_ _null_ n ));

/* last_value_cidr(internal, cidr) => cidr */ 
DATA(insert OID = 7167 ( last_value_cidr  PGNSP PGUID 12 1 0 0 f f t f i 2 0 650 t "2281 650" _null_ _null_ _null_ _null_ last_value_generic _null_ _null_ _null_ n ));

/* last_value_circle(internal, circle) => circle */ 
DATA(insert OID = 7168 ( last_value_circle  PGNSP PGUID 12 1 0 0 f f t f i 2 0 718 t "2281 718" _null_ _null_ _null_ _null_ last_value_generic _null_ _null_ _null_ n ));

/* last_value_float4(internal, float4) => float4 */ 
DATA(insert OID = 7142 ( last_value_float4  PGNSP PGUID 12 1 0 0 f f t f i 2 0 700 t "2281 700" _null_ _null_ _null_ _null_ last_value_generic _null_ _null_ _null_ n ));

/* last_value_float8(internal, float8) => float8 */ 
DATA(insert OID = 7143 ( last_value_float8  PGNSP PGUID 12 1 0 0 f f t f i 2 0 701 t "2281 701" _null_ _null_ _null_ _null_ last_value_generic _null_ _null_ _null_ n ));

/* last_value_inet(internal, inet) => inet */ 
DATA(insert OID = 7144 ( last_value_inet  PGNSP PGUID 12 1 0 0 f f t f i 2 0 869 t "2281 869" _null_ _null_ _null_ _null_ last_value_generic _null_ _null_ _null_ n ));

/* last_value_interval(internal, "interval") => "interval" */ 
DATA(insert OID = 7145 ( last_value_interval  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1186 t "2281 1186" _null_ _null_ _null_ _null_ last_value_generic _null_ _null_ _null_ n ));

/* last_value_line(internal, line) => line */ 
DATA(insert OID = 7146 ( last_value_line  PGNSP PGUID 12 1 0 0 f f t f i 2 0 628 t "2281 628" _null_ _null_ _null_ _null_ last_value_generic _null_ _null_ _null_ n ));

/* last_value_lseg(internal, lseg) => lseg */ 
DATA(insert OID = 7147 ( last_value_lseg  PGNSP PGUID 12 1 0 0 f f t f i 2 0 601 t "2281 601" _null_ _null_ _null_ _null_ last_value_generic _null_ _null_ _null_ n ));

/* last_value_macaddr(internal, macaddr) => macaddr */ 
DATA(insert OID = 7148 ( last_value_macaddr  PGNSP PGUID 12 1 0 0 f f t f i 2 0 829 t "2281 829" _null_ _null_ _null_ _null_ last_value_generic _null_ _null_ _null_ n ));

/* last_value_money(internal, money) => money */ 
DATA(insert OID = 7149 ( last_value_money  PGNSP PGUID 12 1 0 0 f f t f i 2 0 790 t "2281 790" _null_ _null_ _null_ _null_ last_value_generic _null_ _null_ _null_ n ));

/* last_value_name(internal, name) => name */ 
DATA(insert OID = 7150 ( last_value_name  PGNSP PGUID 12 1 0 0 f f t f i 2 0 19 t "2281 19" _null_ _null_ _null_ _null_ last_value_generic _null_ _null_ _null_ n ));

/* last_value_oid(internal, oid) => oid */ 
DATA(insert OID = 7151 ( last_value_oid  PGNSP PGUID 12 1 0 0 f f t f i 2 0 26 t "2281 26" _null_ _null_ _null_ _null_ last_value_generic _null_ _null_ _null_ n ));

/* last_value_path(internal, path) => path */ 
DATA(insert OID = 7152 ( last_value_path  PGNSP PGUID 12 1 0 0 f f t f i 2 0 602 t "2281 602" _null_ _null_ _null_ _null_ last_value_generic _null_ _null_ _null_ n ));

/* last_value_point(internal, point) => point */ 
DATA(insert OID = 7153 ( last_value_point  PGNSP PGUID 12 1 0 0 f f t f i 2 0 600 t "2281 600" _null_ _null_ _null_ _null_ last_value_generic _null_ _null_ _null_ n ));

/* last_value_polygon(internal, polygon) => polygon */ 
DATA(insert OID = 7154 ( last_value_polygon  PGNSP PGUID 12 1 0 0 f f t f i 2 0 604 t "2281 604" _null_ _null_ _null_ _null_ last_value_generic _null_ _null_ _null_ n ));

/* last_value_reltime(internal, reltime) => reltime */ 
DATA(insert OID = 7155 ( last_value_reltime  PGNSP PGUID 12 1 0 0 f f t f i 2 0 703 t "2281 703" _null_ _null_ _null_ _null_ last_value_generic _null_ _null_ _null_ n ));

/* last_value_tid(internal, tid) => tid */ 
DATA(insert OID = 7157 ( last_value_tid  PGNSP PGUID 12 1 0 0 f f t f i 2 0 27 t "2281 27" _null_ _null_ _null_ _null_ last_value_generic _null_ _null_ _null_ n ));

/* last_value_time(internal, "time") => "time" */ 
DATA(insert OID = 7158 ( last_value_time  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1083 t "2281 1083" _null_ _null_ _null_ _null_ last_value_generic _null_ _null_ _null_ n ));

/* last_value_timestamp(internal, "timestamp") => "timestamp" */ 
DATA(insert OID = 7159 ( last_value_timestamp  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1114 t "2281 1114" _null_ _null_ _null_ _null_ last_value_generic _null_ _null_ _null_ n ));

/* last_value_timestamptz(internal, timestamptz) => timestamptz */ 
DATA(insert OID = 7160 ( last_value_timestamptz  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1184 t "2281 1184" _null_ _null_ _null_ _null_ last_value_generic _null_ _null_ _null_ n ));

/* last_value_timetz(internal, timetz) => timetz */ 
DATA(insert OID = 7161 ( last_value_timetz  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1266 t "2281 1266" _null_ _null_ _null_ _null_ last_value_generic _null_ _null_ _null_ n ));

/* last_value_varbit(internal, varbit) => varbit */ 
DATA(insert OID = 7162 ( last_value_varbit  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1562 t "2281 1562" _null_ _null_ _null_ _null_ last_value_generic _null_ _null_ _null_ n ));

/* last_value_varchar(internal, "varchar") => "varchar" */ 
DATA(insert OID = 7163 ( last_value_varchar  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1043 t "2281 1043" _null_ _null_ _null_ _null_ last_value_generic _null_ _null_ _null_ n ));

/* last_value_xid(internal, xid) => xid */ 
DATA(insert OID = 7164 ( last_value_xid  PGNSP PGUID 12 1 0 0 f f t f i 2 0 28 t "2281 28" _null_ _null_ _null_ _null_ last_value_generic _null_ _null_ _null_ n ));

/* last_value_bytea(internal, bytea) => bytea */ 
DATA(insert OID = 7239 ( last_value_bytea  PGNSP PGUID 12 1 0 0 f f t f i 2 0 17 t "2281 17" _null_ _null_ _null_ _null_ last_value_generic _null_ _null_ _null_ n ));

/* last_value_bit(internal, "bit") => "bit" */ 
DATA(insert OID = 7259 ( last_value_bit  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1560 t "2281 1560" _null_ _null_ _null_ _null_ last_value_generic _null_ _null_ _null_ n ));

/* last_value_box(internal, box) => box */ 
DATA(insert OID = 7275 ( last_value_box  PGNSP PGUID 12 1 0 0 f f t f i 2 0 603 t "2281 603" _null_ _null_ _null_ _null_ last_value_generic _null_ _null_ _null_ n ));

/* last_value_any(internal, anyarray) => anyarray */ 
DATA(insert OID = 7291 ( last_value_any  PGNSP PGUID 12 1 0 0 f f t f i 2 0 2277 t "2281 2277" _null_ _null_ _null_ _null_ last_value_generic _null_ _null_ _null_ n ));

/* cume_dist_prelim(internal) => int8 */ 
DATA(insert OID = 7204 ( cume_dist_prelim  PGNSP PGUID 12 1 0 0 f f t f i 1 0 20 f "2281" _null_ _null_ _null_ _null_ cume_dist_prelim _null_ _null_ _null_ n ));
DESCR("window preliminary function");


#define CUME_DIST_PRELIM_OID 7204
#define CUME_DIST_PRELIM_TYPE 20
/* ntile_prelim_int(internal, int4) => _int8 */ 
DATA(insert OID = 7205 ( ntile_prelim_int  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1016 f "2281 23" _null_ _null_ _null_ _null_ ntile_prelim_int _null_ _null_ _null_ n ));
DESCR("window preliminary function");

/* ntile_prelim_bigint(internal, int8) => _int8 */ 
DATA(insert OID = 7206 ( ntile_prelim_bigint  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1016 f "2281 20" _null_ _null_ _null_ _null_ ntile_prelim_bigint _null_ _null_ _null_ n ));
DESCR("window preliminary function");

/* ntile_prelim_numeric(internal, "numeric") => _int8 */ 
DATA(insert OID = 7207 ( ntile_prelim_numeric  PGNSP PGUID 12 1 0 0 f f t f i 2 0 1016 f "2281 1700" _null_ _null_ _null_ _null_ ntile_prelim_numeric _null_ _null_ _null_ n ));
DESCR("window preliminary function");

/* percent_rank_final(int8, int8) => float8 */ 
DATA(insert OID = 7303 ( percent_rank_final  PGNSP PGUID 12 1 0 0 f f t f i 2 0 701 f "20 20" _null_ _null_ _null_ _null_ percent_rank_final _null_ _null_ _null_ n ));
DESCR("window final function");

/* cume_dist_final(int8, int8) => float8 */ 
DATA(insert OID = 7304 ( cume_dist_final  PGNSP PGUID 12 1 0 0 f f t f i 2 0 701 f "20 20" _null_ _null_ _null_ _null_ cume_dist_final _null_ _null_ _null_ n ));
DESCR("window final function");

/* ntile_final(_int8, int8) => int8 */ 
DATA(insert OID = 7305 ( ntile_final  PGNSP PGUID 12 1 0 0 f f t f i 2 0 20 f "1016 20" _null_ _null_ _null_ _null_ ntile_final _null_ _null_ _null_ n ));
DESCR("window final function");

/* get_ao_distribution(IN reloid oid, OUT segmentid int4, OUT tupcount int8) => SETOF pg_catalog.record */ 
DATA(insert OID = 7169 ( get_ao_distribution  PGNSP PGUID 12 1 1000 0 f f f t v 1 0 2249 f "26" "{26,23,20}" "{i,o,o}" "{reloid,segmentid,tupcount}" _null_ get_ao_distribution_oid _null_ _null_ _null_ r ));
DESCR("show append only table tuple distribution across segment databases");

/* get_ao_distribution(IN relname text, OUT segmentid int4, OUT tupcount int8) => SETOF pg_catalog.record */ 
DATA(insert OID = 7170 ( get_ao_distribution  PGNSP PGUID 12 1 1000 0 f f f t v 1 0 2249 f "25" "{25,23,20}" "{i,o,o}" "{relname,segmentid,tupcount}" _null_ get_ao_distribution_name _null_ _null_ _null_ r ));
DESCR("show append only table tuple distribution across segment databases");

/* get_ao_compression_ratio(oid) => float8 */ 
DATA(insert OID = 7171 ( get_ao_compression_ratio  PGNSP PGUID 12 1 0 0 f f t f v 1 0 701 f "26" _null_ _null_ _null_ _null_ get_ao_compression_ratio_oid _null_ _null_ _null_ r ));
DESCR("show append only table compression ratio");

/* get_ao_compression_ratio(text) => float8 */ 
DATA(insert OID = 7172 ( get_ao_compression_ratio  PGNSP PGUID 12 1 0 0 f f t f v 1 0 701 f "25" _null_ _null_ _null_ _null_ get_ao_compression_ratio_name _null_ _null_ _null_ r ));
DESCR("show append only table compression ratio");

/* gp_update_ao_master_stats(oid) => int8 */ 
DATA(insert OID = 7173 ( gp_update_ao_master_stats  PGNSP PGUID 12 1 0 0 f f f f v 1 0 20 f "26" _null_ _null_ _null_ _null_ gp_update_ao_master_stats_oid _null_ _null_ _null_ m ));
DESCR("append only tables utility function");

/* gp_update_ao_master_stats(text) => int8 */ 
DATA(insert OID = 7174 ( gp_update_ao_master_stats  PGNSP PGUID 12 1 0 0 f f f f v 1 0 20 f "25" _null_ _null_ _null_ _null_ gp_update_ao_master_stats_name _null_ _null_ _null_ m ));
DESCR("append only tables utility function");

/* gp_persistent_build_db(bool) => int4 */ 
DATA(insert OID = 7178 ( gp_persistent_build_db  PGNSP PGUID 12 1 0 0 f f f f v 1 0 23 f "16" _null_ _null_ _null_ _null_ gp_persistent_build_db _null_ _null_ _null_ n ));
DESCR("populate the persistent tables and gp_relation_node for the current database");

/* gp_persistent_build_all(bool) => int4 */ 
DATA(insert OID = 7179 ( gp_persistent_build_all  PGNSP PGUID 12 1 0 0 f f f f v 1 0 23 f "16" _null_ _null_ _null_ _null_ gp_persistent_build_all _null_ _null_ _null_ n ));
DESCR("populate the persistent tables and gp_relation_node for the whole database instance");

/* gp_persistent_reset_all() => int4 */ 
DATA(insert OID = 7180 ( gp_persistent_reset_all  PGNSP PGUID 12 1 0 0 f f f f v 0 0 23 f "" _null_ _null_ _null_ _null_ gp_persistent_reset_all _null_ _null_ _null_ n ));
DESCR("Remove the persistent tables and gp_relation_node for the whole database instance");

/* gp_persistent_repair_delete(int4, tid) => int4 */ 
DATA(insert OID = 7181 ( gp_persistent_repair_delete  PGNSP PGUID 12 1 0 0 f f f f v 2 0 23 f "23 27" _null_ _null_ _null_ _null_ gp_persistent_repair_delete _null_ _null_ _null_ n ));
DESCR("Remove an entry specified by TID from a persistent table for the current database instance");

/* xmlexists(text, xml) => bool */ 
DATA(insert OID = 2985 ( xmlexists  PGNSP PGUID 12 1 0 0 f f t f i 2 0 16 f "25 142" _null_ _null_ _null_ _null_ xmlexists _null_ _null_ _null_ n ));
DESCR("test XML value against XPath expression");

/* xpath_exists(text, xml, _text) => bool */ 
DATA(insert OID = 2986 ( xpath_exists  PGNSP PGUID 12 1 0 0 f f t f i 3 0 16 f "25 142 1009" _null_ _null_ _null_ _null_ xpath_exists _null_ _null_ _null_ n ));
DESCR("test XML value against XPath expression, with namespace support");

/* xpath_exists(text, xml) => bool */ 
DATA(insert OID = 3049 ( xpath_exists  PGNSP PGUID 14 1 0 0 f f t f i 2 0 16 f "25 142" _null_ _null_ _null_ _null_ "select pg_catalog.xpath_exists($1, $2, ''{}''::pg_catalog.text[])" _null_ _null_ _null_ c ));
DESCR("test XML value against XPath expression");

/* xml_is_well_formed(text) => bool */ 
DATA(insert OID = 2988 ( xml_is_well_formed  PGNSP PGUID 12 1 0 0 f f t f i 1 0 16 f "25" _null_ _null_ _null_ _null_ xml_is_well_formed _null_ _null_ _null_ n ));
DESCR("determine if a string is well formed XML");

/* xml_is_well_formed_document(text) => bool */ 
DATA(insert OID = 2989 ( xml_is_well_formed_document  PGNSP PGUID 12 1 0 0 f f t f i 1 0 16 f "25" _null_ _null_ _null_ _null_ xml_is_well_formed_document _null_ _null_ _null_ n ));
DESCR("determine if a string is well formed XML document");

/* xml_is_well_formed_content(text) => bool */ 
DATA(insert OID = 2990 ( xml_is_well_formed_content  PGNSP PGUID 12 1 0 0 f f t f i 1 0 16 f "25" _null_ _null_ _null_ _null_ xml_is_well_formed_content _null_ _null_ _null_ n ));
DESCR("determine if a string is well formed XML content");


/* the bitmap index access method routines */
/* bmgettuple(internal, internal) => bool */ 
DATA(insert OID = 3050 ( bmgettuple  PGNSP PGUID 12 1 0 0 f f t f v 2 0 16 f "2281 2281" _null_ _null_ _null_ _null_ bmgettuple _null_ _null_ _null_ n ));
DESCR("bitmap(internal)");

/* bmgetmulti(internal, internal) => internal */ 
DATA(insert OID = 3051 ( bmgetmulti  PGNSP PGUID 12 1 0 0 f f t f v 2 0 2281 f "2281 2281" _null_ _null_ _null_ _null_ bmgetmulti _null_ _null_ _null_ n ));
DESCR("bitmap(internal)");

/* bminsert(internal, internal, internal, internal, internal, internal) => bool */ 
DATA(insert OID = 3001 ( bminsert  PGNSP PGUID 12 1 0 0 f f t f v 6 0 16 f "2281 2281 2281 2281 2281 2281" _null_ _null_ _null_ _null_ bminsert _null_ _null_ _null_ n ));
DESCR("bitmap(internal)");

/* bmbeginscan(internal, internal, internal) => internal */ 
DATA(insert OID = 3002 ( bmbeginscan  PGNSP PGUID 12 1 0 0 f f t f v 3 0 2281 f "2281 2281 2281" _null_ _null_ _null_ _null_ bmbeginscan _null_ _null_ _null_ n ));
DESCR("bitmap(internal)");

/* bmrescan(internal, internal) => void */ 
DATA(insert OID = 3003 ( bmrescan  PGNSP PGUID 12 1 0 0 f f t f v 2 0 2278 f "2281 2281" _null_ _null_ _null_ _null_ bmrescan _null_ _null_ _null_ n ));
DESCR("bitmap(internal)");

/* bmendscan(internal) => void */ 
DATA(insert OID = 3004 ( bmendscan  PGNSP PGUID 12 1 0 0 f f t f v 1 0 2278 f "2281" _null_ _null_ _null_ _null_ bmendscan _null_ _null_ _null_ n ));
DESCR("bitmap(internal)");

/* bmmarkpos(internal) => void */ 
DATA(insert OID = 3005 ( bmmarkpos  PGNSP PGUID 12 1 0 0 f f t f v 1 0 2278 f "2281" _null_ _null_ _null_ _null_ bmmarkpos _null_ _null_ _null_ n ));
DESCR("bitmap(internal)");

/* bmrestrpos(internal) => void */ 
DATA(insert OID = 3006 ( bmrestrpos  PGNSP PGUID 12 1 0 0 f f t f v 1 0 2278 f "2281" _null_ _null_ _null_ _null_ bmrestrpos _null_ _null_ _null_ n ));
DESCR("bitmap(internal)");

/* bmbuild(internal, internal, internal) => internal */ 
DATA(insert OID = 3007 ( bmbuild  PGNSP PGUID 12 1 0 0 f f t f v 3 0 2281 f "2281 2281 2281" _null_ _null_ _null_ _null_ bmbuild _null_ _null_ _null_ n ));
DESCR("bitmap(internal)");

/* bmbulkdelete(internal, internal, internal, internal) => internal */ 
DATA(insert OID = 3008 ( bmbulkdelete  PGNSP PGUID 12 1 0 0 f f t f v 4 0 2281 f "2281 2281 2281 2281" _null_ _null_ _null_ _null_ bmbulkdelete _null_ _null_ _null_ n ));
DESCR("bitmap(internal)");

/* bmvacuumcleanup(internal, internal) => internal */ 
DATA(insert OID = 3009 ( bmvacuumcleanup  PGNSP PGUID 12 1 0 0 f f t f v 2 0 2281 f "2281 2281" _null_ _null_ _null_ _null_ bmvacuumcleanup _null_ _null_ _null_ n ));

/* bmcostestimate(internal, internal, internal, internal, internal, internal, internal, internal) => void */ 
DATA(insert OID = 3010 ( bmcostestimate  PGNSP PGUID 12 1 0 0 f f t f v 8 0 2278 f "2281 2281 2281 2281 2281 2281 2281 2281" _null_ _null_ _null_ _null_ bmcostestimate _null_ _null_ _null_ n ));
DESCR("bitmap(internal)");

/* bmoptions(_text, bool) => bytea */ 
DATA(insert OID = 3011 ( bmoptions  PGNSP PGUID 12 1 0 0 f f t f s 2 0 17 f "1009 16" _null_ _null_ _null_ _null_ bmoptions _null_ _null_ _null_ n ));
DESCR("btree(internal)");


/* AOCS functions. */
/* aocsvpinfo_decode(bytea, int4, int4) => int8 */ 
DATA(insert OID = 9900 ( aocsvpinfo_decode  PGNSP PGUID 12 1 0 0 f f t f i 3 0 20 f "17 23 23" _null_ _null_ _null_ _null_ aocsvpinfo_decode _null_ _null_ _null_ n ));


/* raises deprecation error */
/* gp_deprecated() => void */ 
DATA(insert OID = 9997 ( gp_deprecated  PGNSP PGUID 12 1 0 0 f f f f i 0 0 2278 f "" _null_ _null_ _null_ _null_ gp_deprecated _null_ _null_ _null_ n ));
DESCR("raises function deprecation error");


/* A convenient utility */
/* pg_objname_to_oid(text) => oid */ 
DATA(insert OID = 9998 ( pg_objname_to_oid  PGNSP PGUID 12 1 0 0 f f t f i 1 0 26 f "25" _null_ _null_ _null_ _null_ pg_objname_to_oid _null_ _null_ _null_ n ));
DESCR("convert an object name to oid");


/* Fault injection */
/* gp_fault_inject(int4, int8) => int8 */ 
DATA(insert OID = 9999 ( gp_fault_inject  PGNSP PGUID 12 1 0 0 f f t f v 2 0 20 f "23 20" _null_ _null_ _null_ _null_ gp_fault_inject _null_ _null_ _null_ n ));
DESCR("Greenplum fault testing only");


/* Analyze related */
/* gp_statistics_estimate_reltuples_relpages_oid(oid) => _float4 */ 
DATA(insert OID = 5032 ( gp_statistics_estimate_reltuples_relpages_oid  PGNSP PGUID 12 1 0 0 f f t f v 1 0 1021 f "26" _null_ _null_ _null_ _null_ gp_statistics_estimate_reltuples_relpages_oid _null_ _null_ _null_ n ));
DESCR("Return reltuples/relpages information for relation.");


/* Backoff related */
/* gp_adjust_priority(int4, int4, int4) => int4 */ 
DATA(insert OID = 5040 ( gp_adjust_priority  PGNSP PGUID 12 1 0 0 f f t f v 3 0 23 f "23 23 23" _null_ _null_ _null_ _null_ gp_adjust_priority_int _null_ _null_ _null_ n ));
DESCR("change weight of all the backends for a given session id");

/* gp_adjust_priority(int4, int4, text) => int4 */ 
DATA(insert OID = 5041 ( gp_adjust_priority  PGNSP PGUID 12 1 0 0 f f t f v 3 0 23 f "23 23 25" _null_ _null_ _null_ _null_ gp_adjust_priority_value _null_ _null_ _null_ n ));
DESCR("change weight of all the backends for a given session id");

/* gp_list_backend_priorities() => SETOF record */ 
DATA(insert OID = 5042 ( gp_list_backend_priorities  PGNSP PGUID 12 1 1000 0 f f f t v 0 0 2249 f "" _null_ _null_ _null_ _null_ gp_list_backend_priorities _null_ _null_ _null_ n ));
DESCR("list priorities of backends");


/* elog related */
/* gp_elog(text) => void */ 
DATA(insert OID = 5044 ( gp_elog  PGNSP PGUID 12 1 0 0 f f t f i 1 0 2278 f "25" _null_ _null_ _null_ _null_ gp_elog _null_ _null_ _null_ n ));
DESCR("Insert text into the error log");

/* gp_elog(text, bool) => void */ 
DATA(insert OID = 5045 ( gp_elog  PGNSP PGUID 12 1 0 0 f f t f i 2 0 2278 f "25 16" _null_ _null_ _null_ _null_ gp_elog _null_ _null_ _null_ n ));
DESCR("Insert text into the error log");


/* Segment and master administration functions, see utils/gp/segadmin.c */
/* gp_add_master_standby(text, text, _text) => int2 */ 
DATA(insert OID = 5046 ( gp_add_master_standby  PGNSP PGUID 12 1 0 0 f f f f v 3 0 21 f "25 25 1009" _null_ _null_ _null_ _null_ gp_add_master_standby _null_ _null_ _null_ n ));
DESCR("Perform the catalog operations necessary for adding a new standby");

/* gp_add_master_standby(text, text, _text, int4) => int2 */ 
DATA(insert OID = 5038 ( gp_add_master_standby  PGNSP PGUID 12 1 0 0 f f f f v 4 0 21 f "25 25 1009 23" _null_ _null_ _null_ _null_ gp_add_master_standby_port _null_ _null_ _null_ n ));
DESCR("Perform the catalog operations necessary for adding a new standby");

/* gp_remove_master_standby() => bool */ 
DATA(insert OID = 5047 ( gp_remove_master_standby  PGNSP PGUID 12 1 0 0 f f f f v 0 0 16 f "" _null_ _null_ _null_ _null_ gp_remove_master_standby _null_ _null_ _null_ n ));
DESCR("Remove a master standby from the system catalog");

/* gp_add_segment_mirror(int2, text, text, int4, int4, _text) => int2 */ 
DATA(insert OID = 5048 ( gp_add_segment_mirror  PGNSP PGUID 12 1 0 0 f f f f v 6 0 21 f "21 25 25 23 23 1009" _null_ _null_ _null_ _null_ gp_add_segment_mirror _null_ _null_ _null_ n ));
DESCR("Perform the catalog operations necessary for adding a new segment mirror");

/* gp_remove_segment_mirror(int2) => bool */ 
DATA(insert OID = 5049 ( gp_remove_segment_mirror  PGNSP PGUID 12 1 0 0 f f f f v 1 0 16 f "21" _null_ _null_ _null_ _null_ gp_remove_segment_mirror _null_ _null_ _null_ n ));
DESCR("Remove a segment mirror from the system catalog");

/* gp_add_segment(text, text, int4, _text) => int2 */ 
DATA(insert OID = 5050 ( gp_add_segment  PGNSP PGUID 12 1 0 0 f f f f v 4 0 21 f "25 25 23 1009" _null_ _null_ _null_ _null_ gp_add_segment _null_ _null_ _null_ n ));
DESCR("Perform the catalog operations necessary for adding a new primary segment");

/* gp_remove_segment(int2) => bool */ 
DATA(insert OID = 5051 ( gp_remove_segment  PGNSP PGUID 12 1 0 0 f f f f v 1 0 16 f "21" _null_ _null_ _null_ _null_ gp_remove_segment _null_ _null_ _null_ n ));
DESCR("Remove a primary segment from the system catalog");

/* gp_prep_new_segment(_text) => bool */ 
DATA(insert OID = 5052 ( gp_prep_new_segment  PGNSP PGUID 12 1 0 0 f f f f v 1 0 16 f "1009" _null_ _null_ _null_ _null_ gp_prep_new_segment _null_ _null_ _null_ n ));
DESCR("Convert a cloned master catalog for use as a segment");

/* gp_activate_standby() => bool */ 
DATA(insert OID = 5053 ( gp_activate_standby  PGNSP PGUID 12 1 0 0 f f f f v 0 0 16 f "" _null_ _null_ _null_ _null_ gp_activate_standby _null_ _null_ _null_ n ));
DESCR("Activate a standby");


/* We cheat in the following two functions: they are technically volatile but */
/* we can only dispatch them if they're immutable :(. */
/* gp_add_segment_persistent_entries(int2, int2, _text) => bool */ 
DATA(insert OID = 5054 ( gp_add_segment_persistent_entries  PGNSP PGUID 12 1 0 0 f f f f i 3 0 16 f "21 21 1009" _null_ _null_ _null_ _null_ gp_add_segment_persistent_entries _null_ _null_ _null_ n ));
DESCR("Persist object nodes on a segment");

/* gp_remove_segment_persistent_entries(int2, int2) => bool */ 
DATA(insert OID = 5055 ( gp_remove_segment_persistent_entries  PGNSP PGUID 12 1 0 0 f f f f i 2 0 16 f "21 21" _null_ _null_ _null_ _null_ gp_remove_segment_persistent_entries _null_ _null_ _null_ n ));
DESCR("Remove persistent object node references at a segment");


/* persistent table repair functions */
/* gp_add_persistent_filespace_node_entry(tid, oid, int2, text, int2, text, int2, int8, int2, int4, int4, int8) => bool */ 
DATA(insert OID = 5056 ( gp_add_persistent_filespace_node_entry  PGNSP PGUID 12 1 0 0 f f f f v 12 0 16 f "27 26 21 25 21 25 21 20 21 23 23 20" _null_ _null_ _null_ _null_ gp_add_persistent_filespace_node_entry _null_ _null_ _null_ n ));
DESCR("Add a new entry to gp_persistent_filespace_node");

/* gp_add_persistent_tablespace_node_entry(tid, oid, oid, int2, int8, int2, int4, int4, int8) => bool */ 
DATA(insert OID = 5057 ( gp_add_persistent_tablespace_node_entry  PGNSP PGUID 12 1 0 0 f f f f v 9 0 16 f "27 26 26 21 20 21 23 23 20" _null_ _null_ _null_ _null_ gp_add_persistent_tablespace_node_entry _null_ _null_ _null_ n ));
DESCR("Add a new entry to gp_persistent_tablespace_node");

/* gp_add_persistent_database_node_entry(tid, oid, oid, int2, int8, int2, int4, int4, int8) => bool */ 
DATA(insert OID = 5058 ( gp_add_persistent_database_node_entry  PGNSP PGUID 12 1 0 0 f f f f v 9 0 16 f "27 26 26 21 20 21 23 23 20" _null_ _null_ _null_ _null_ gp_add_persistent_database_node_entry _null_ _null_ _null_ n ));
DESCR("Add a new entry to gp_persistent_database_node");

/* gp_add_persistent_relation_node_entry(tid, oid, oid, oid, int4, int2, int2, int8, int2, int2, bool, int8, gpxlogloc, int4, int8, int8, int4, int4, int8) => bool */ 
DATA(insert OID = 5059 ( gp_add_persistent_relation_node_entry  PGNSP PGUID 12 1 0 0 f f f f v 19 0 16 f "27 26 26 26 23 21 21 20 21 21 16 20 3310 23 20 20 23 23 20" _null_ _null_ _null_ _null_ gp_add_persistent_relation_node_entry _null_ _null_ _null_ n ));
DESCR("Add a new entry to gp_persistent_relation_node");

/* gp_add_global_sequence_entry(tid, int8) => bool */ 
DATA(insert OID = 5060 ( gp_add_global_sequence_entry  PGNSP PGUID 12 1 0 0 f f f f v 2 0 16 f "27 20" _null_ _null_ _null_ _null_ gp_add_global_sequence_entry _null_ _null_ _null_ n ));
DESCR("Add a new entry to gp_global_sequence");

/* gp_add_relation_node_entry(tid, oid, oid, int4, int8, tid, int8) => bool */ 
DATA(insert OID = 5061 ( gp_add_relation_node_entry  PGNSP PGUID 12 1 0 0 f f f f v 7 0 16 f "27 26 26 23 20 27 20" _null_ _null_ _null_ _null_ gp_add_relation_node_entry _null_ _null_ _null_ n ));
DESCR("Add a new entry to gp_relation_node");

/* gp_update_persistent_filespace_node_entry(tid, oid, int2, text, int2, text, int2, int8, int2, int4, int4, int8) => bool */ 
DATA(insert OID = 5062 ( gp_update_persistent_filespace_node_entry  PGNSP PGUID 12 1 0 0 f f f f v 12 0 16 f "27 26 21 25 21 25 21 20 21 23 23 20" _null_ _null_ _null_ _null_ gp_update_persistent_filespace_node_entry _null_ _null_ _null_ n ));
DESCR("Update an entry in gp_persistent_filespace_node");

/* gp_update_persistent_tablespace_node_entry(tid, oid, oid, int2, int8, int2, int4, int4, int8) => bool */ 
DATA(insert OID = 5063 ( gp_update_persistent_tablespace_node_entry  PGNSP PGUID 12 1 0 0 f f f f v 9 0 16 f "27 26 26 21 20 21 23 23 20" _null_ _null_ _null_ _null_ gp_update_persistent_tablespace_node_entry _null_ _null_ _null_ n ));
DESCR("Update an entry in gp_persistent_tablespace_node");

/* gp_update_persistent_database_node_entry(tid, oid, oid, int2, int8, int2, int4, int4, int8) => bool */ 
DATA(insert OID = 5064 ( gp_update_persistent_database_node_entry  PGNSP PGUID 12 1 0 0 f f f f v 9 0 16 f "27 26 26 21 20 21 23 23 20" _null_ _null_ _null_ _null_ gp_update_persistent_database_node_entry _null_ _null_ _null_ n ));
DESCR("Update an entry in gp_persistent_database_node");

/* gp_update_persistent_relation_node_entry(tid, oid, oid, oid, int4, int2, int2, int8, int2, int2, bool, int8, gpxlogloc, int4, int8, int8, int4, int4, int8) => bool */ 
DATA(insert OID = 5065 ( gp_update_persistent_relation_node_entry  PGNSP PGUID 12 1 0 0 f f f f v 19 0 16 f "27 26 26 26 23 21 21 20 21 21 16 20 3310 23 20 20 23 23 20" _null_ _null_ _null_ _null_ gp_update_persistent_relation_node_entry _null_ _null_ _null_ n ));
DESCR("Update an entry in gp_persistent_relation_node");

/* gp_update_global_sequence_entry(tid, int8) => bool */ 
DATA(insert OID = 5066 ( gp_update_global_sequence_entry  PGNSP PGUID 12 1 0 0 f f f f v 2 0 16 f "27 20" _null_ _null_ _null_ _null_ gp_update_global_sequence_entry _null_ _null_ _null_ n ));
DESCR("Update an entry in gp_global_sequence");

/* gp_update_relation_node_entry(tid, oid, oid, int4, int8, tid, int8) => bool */ 
DATA(insert OID = 5067 ( gp_update_relation_node_entry  PGNSP PGUID 12 1 0 0 f f f f v 7 0 16 f "27 26 26 23 20 27 20" _null_ _null_ _null_ _null_ gp_update_relation_node_entry _null_ _null_ _null_ n ));
DESCR("Update an entry in gp_relation_node");

/* gp_delete_persistent_filespace_node_entry(tid) => bool */ 
DATA(insert OID = 5068 ( gp_delete_persistent_filespace_node_entry  PGNSP PGUID 12 1 0 0 f f f f v 1 0 16 f "27" _null_ _null_ _null_ _null_ gp_delete_persistent_filespace_node_entry _null_ _null_ _null_ n ));
DESCR("Remove an entry from gp_persistent_filespace_node");

/* gp_delete_persistent_tablespace_node_entry(tid) => bool */ 
DATA(insert OID = 5069 ( gp_delete_persistent_tablespace_node_entry  PGNSP PGUID 12 1 0 0 f f f f v 1 0 16 f "27" _null_ _null_ _null_ _null_ gp_delete_persistent_tablespace_node_entry _null_ _null_ _null_ n ));
DESCR("Remove an entry from gp_persistent_tablespace_node");

/* gp_delete_persistent_database_node_entry(tid) => bool */ 
DATA(insert OID = 5070 ( gp_delete_persistent_database_node_entry  PGNSP PGUID 12 1 0 0 f f f f v 1 0 16 f "27" _null_ _null_ _null_ _null_ gp_delete_persistent_database_node_entry _null_ _null_ _null_ n ));
DESCR("Remove an entry from gp_persistent_database_node");

/* gp_delete_persistent_relation_node_entry(tid) => bool */ 
DATA(insert OID = 5071 ( gp_delete_persistent_relation_node_entry  PGNSP PGUID 12 1 0 0 f f f f v 1 0 16 f "27" _null_ _null_ _null_ _null_ gp_delete_persistent_relation_node_entry _null_ _null_ _null_ n ));
DESCR("Remove an entry from gp_persistent_relation_node");

/* gp_delete_global_sequence_entry(tid) => bool */ 
DATA(insert OID = 5072 ( gp_delete_global_sequence_entry  PGNSP PGUID 12 1 0 0 f f f f v 1 0 16 f "27" _null_ _null_ _null_ _null_ gp_delete_global_sequence_entry _null_ _null_ _null_ n ));
DESCR("Remove an entry from gp_global_sequence");

/* gp_delete_relation_node_entry(tid) => bool */ 
DATA(insert OID = 5073 ( gp_delete_relation_node_entry  PGNSP PGUID 12 1 0 0 f f f f v 1 0 16 f "27" _null_ _null_ _null_ _null_ gp_delete_relation_node_entry _null_ _null_ _null_ n ));
DESCR("Remove an entry from gp_relation_node");

/* gp_persistent_relation_node_check() => SETOF gp_persistent_relation_node */ 
DATA(insert OID = 5074 ( gp_persistent_relation_node_check  PGNSP PGUID 12 1 1000 0 f f f t v 0 0 6990 f "" _null_ _null_ _null_ _null_ gp_persistent_relation_node_check _null_ _null_ _null_ n ));
DESCR("physical filesystem information");

/* gp_dbspecific_ptcat_verification() => bool */ 
DATA(insert OID = 5075 ( gp_dbspecific_ptcat_verification  PGNSP PGUID 12 1 0 0 f f f f v 0 0 16 f "" _null_ _null_ _null_ _null_ gp_dbspecific_ptcat_verification _null_ _null_ _null_ n ));
DESCR("perform database specific PersistentTables-Catalog verification");

/* gp_nondbspecific_ptcat_verification() => bool */ 
DATA(insert OID = 5080 ( gp_nondbspecific_ptcat_verification  PGNSP PGUID 12 1 0 0 f f f f v 0 0 16 f "" _null_ _null_ _null_ _null_ gp_nondbspecific_ptcat_verification _null_ _null_ _null_ n ));
DESCR("perform non-database specific PersistentTables-Catalog verification");

/* cosh(float8) => float8 */ 
DATA(insert OID = 3539 ( cosh  PGNSP PGUID 12 1 0 0 f f f f i 1 0 701 f "701" _null_ _null_ _null_ _null_ dcosh _null_ _null_ _null_ n ));
DESCR("Hyperbolic cosine function");

/* sinh(float8) => float8 */ 
DATA(insert OID = 3540 ( sinh  PGNSP PGUID 12 1 0 0 f f f f i 1 0 701 f "701" _null_ _null_ _null_ _null_ dsinh _null_ _null_ _null_ n ));
DESCR("Hyperbolic sine function");

/* tanh(float8) => float8 */ 
DATA(insert OID = 3541 ( tanh  PGNSP PGUID 12 1 0 0 f f f f i 1 0 701 f "701" _null_ _null_ _null_ _null_ dtanh _null_ _null_ _null_ n ));
DESCR("Hyperbolic tangent function");

/* anytable_in(cstring) => anytable */ 
DATA(insert OID = 3054 ( anytable_in  PGNSP PGUID 12 1 0 0 f f t f i 1 0 3053 f "2275" _null_ _null_ _null_ _null_ anytable_in _null_ _null_ _null_ n ));
DESCR("anytable type serialization input function");

/* anytable_out(anytable) => cstring */ 
DATA(insert OID = 3055 ( anytable_out  PGNSP PGUID 12 1 0 0 f f t f i 1 0 2275 f "3053" _null_ _null_ _null_ _null_ anytable_out _null_ _null_ _null_ n ));
DESCR("anytable type serialization output function");

/* gp_quicklz_constructor(internal, internal, bool) => internal */ 
DATA(insert OID = 5076 ( gp_quicklz_constructor  PGNSP PGUID 12 1 0 0 f f f f v 3 0 2281 f "2281 2281 16" _null_ _null_ _null_ _null_ quicklz_constructor _null_ _null_ _null_ n ));
DESCR("quicklz constructor");

/* gp_quicklz_destructor(internal) => void */ 
DATA(insert OID = 5077 ( gp_quicklz_destructor  PGNSP PGUID 12 1 0 0 f f f f v 1 0 2278 f "2281" _null_ _null_ _null_ _null_ quicklz_destructor _null_ _null_ _null_ n ));
DESCR("quicklz destructor");

/* gp_quicklz_compress(internal, int4, internal, int4, internal, internal) => void */ 
DATA(insert OID = 5078 ( gp_quicklz_compress  PGNSP PGUID 12 1 0 0 f f f f i 6 0 2278 f "2281 23 2281 23 2281 2281" _null_ _null_ _null_ _null_ quicklz_compress _null_ _null_ _null_ n ));
DESCR("quicklz compressor");

/* gp_quicklz_decompress(internal, int4, internal, int4, internal, internal) => void */ 
DATA(insert OID = 5079 ( gp_quicklz_decompress  PGNSP PGUID 12 1 0 0 f f f f i 6 0 2278 f "2281 23 2281 23 2281 2281" _null_ _null_ _null_ _null_ quicklz_decompress _null_ _null_ _null_ n ));
DESCR("quicklz decompressor");

/* gp_quicklz_validator(internal) => void */ 
DATA(insert OID = 9925 ( gp_quicklz_validator  PGNSP PGUID 12 1 0 0 f f f f i 1 0 2278 f "2281" _null_ _null_ _null_ _null_ quicklz_validator _null_ _null_ _null_ n ));
DESCR("quicklz compression validator");

/* gp_zlib_constructor(internal, internal, bool) => internal */ 
DATA(insert OID = 9910 ( gp_zlib_constructor  PGNSP PGUID 12 1 0 0 f f f f v 3 0 2281 f "2281 2281 16" _null_ _null_ _null_ _null_ zlib_constructor _null_ _null_ _null_ n ));
DESCR("zlib constructor");

/* gp_zlib_destructor(internal) => void */ 
DATA(insert OID = 9911 ( gp_zlib_destructor  PGNSP PGUID 12 1 0 0 f f f f v 1 0 2278 f "2281" _null_ _null_ _null_ _null_ zlib_destructor _null_ _null_ _null_ n ));
DESCR("zlib destructor");

/* gp_zlib_compress(internal, int4, internal, int4, internal, internal) => void */ 
DATA(insert OID = 9912 ( gp_zlib_compress  PGNSP PGUID 12 1 0 0 f f f f i 6 0 2278 f "2281 23 2281 23 2281 2281" _null_ _null_ _null_ _null_ zlib_compress _null_ _null_ _null_ n ));
DESCR("zlib compressor");

/* gp_zlib_decompress(internal, int4, internal, int4, internal, internal) => void */ 
DATA(insert OID = 9913 ( gp_zlib_decompress  PGNSP PGUID 12 1 0 0 f f f f i 6 0 2278 f "2281 23 2281 23 2281 2281" _null_ _null_ _null_ _null_ zlib_decompress _null_ _null_ _null_ n ));
DESCR("zlib decompressor");

/* gp_zlib_validator(internal) => void */ 
DATA(insert OID = 9924 ( gp_zlib_validator  PGNSP PGUID 12 1 0 0 f f f f i 1 0 2278 f "2281" _null_ _null_ _null_ _null_ zlib_validator _null_ _null_ _null_ n ));
DESCR("zlib compression validator");

/* gp_rle_type_constructor(internal, internal, bool) => internal */ 
DATA(insert OID = 9914 ( gp_rle_type_constructor  PGNSP PGUID 12 1 0 0 f f f f v 3 0 2281 f "2281 2281 16" _null_ _null_ _null_ _null_ rle_type_constructor _null_ _null_ _null_ n ));
DESCR("Type specific RLE constructor");

/* gp_rle_type_destructor(internal) => void */ 
DATA(insert OID = 9915 ( gp_rle_type_destructor  PGNSP PGUID 12 1 0 0 f f f f v 1 0 2278 f "2281" _null_ _null_ _null_ _null_ rle_type_destructor _null_ _null_ _null_ n ));
DESCR("Type specific RLE destructor");

/* gp_rle_type_compress(internal, int4, internal, int4, internal, internal) => void */ 
DATA(insert OID = 9916 ( gp_rle_type_compress  PGNSP PGUID 12 1 0 0 f f f f i 6 0 2278 f "2281 23 2281 23 2281 2281" _null_ _null_ _null_ _null_ rle_type_compress _null_ _null_ _null_ n ));
DESCR("Type specific RLE compressor");

/* gp_rle_type_decompress(internal, int4, internal, int4, internal, internal) => void */ 
DATA(insert OID = 9917 ( gp_rle_type_decompress  PGNSP PGUID 12 1 0 0 f f f f i 6 0 2278 f "2281 23 2281 23 2281 2281" _null_ _null_ _null_ _null_ rle_type_decompress _null_ _null_ _null_ n ));
DESCR("Type specific RLE decompressor");

/* gp_rle_type_validator(internal) => void */ 
DATA(insert OID = 9923 ( gp_rle_type_validator  PGNSP PGUID 12 1 0 0 f f f f i 1 0 2278 f "2281" _null_ _null_ _null_ _null_ rle_type_validator _null_ _null_ _null_ n ));
DESCR("Type speific RLE compression validator");

/* gp_dummy_compression_constructor(internal, internal, bool) => internal */ 
DATA(insert OID = 3064 ( gp_dummy_compression_constructor  PGNSP PGUID 12 1 0 0 f f f f v 3 0 2281 f "2281 2281 16" _null_ _null_ _null_ _null_ dummy_compression_constructor _null_ _null_ _null_ n ));
DESCR("Dummy compression destructor");

/* gp_dummy_compression_destructor(internal) => internal */ 
DATA(insert OID = 3065 ( gp_dummy_compression_destructor  PGNSP PGUID 12 1 0 0 f f f f v 1 0 2281 f "2281" _null_ _null_ _null_ _null_ dummy_compression_destructor _null_ _null_ _null_ n ));
DESCR("Dummy compression destructor");

/* gp_dummy_compression_compress(internal, int4, internal, int4, internal, internal) => internal */ 
DATA(insert OID = 3066 ( gp_dummy_compression_compress  PGNSP PGUID 12 1 0 0 f f f f v 6 0 2281 f "2281 23 2281 23 2281 2281" _null_ _null_ _null_ _null_ dummy_compression_compress _null_ _null_ _null_ n ));
DESCR("Dummy compression compressor");

/* gp_dummy_compression_decompress(internal, int4, internal, int4, internal, internal) => internal */ 
DATA(insert OID = 3067 ( gp_dummy_compression_decompress  PGNSP PGUID 12 1 0 0 f f f f v 6 0 2281 f "2281 23 2281 23 2281 2281" _null_ _null_ _null_ _null_ dummy_compression_decompress _null_ _null_ _null_ n ));
DESCR("Dummy compression decompressor");

/* gp_dummy_compression_validator(internal) => internal */ 
DATA(insert OID = 3068 ( gp_dummy_compression_validator  PGNSP PGUID 12 1 0 0 f f f f v 1 0 2281 f "2281" _null_ _null_ _null_ _null_ dummy_compression_validator _null_ _null_ _null_ n ));
DESCR("Dummy compression validator");

/* linear_interpolate( anyelement, anyelement, int8, anyelement, int8) => int8 */ 
DATA(insert OID = 6072 ( linear_interpolate  PGNSP PGUID 12 1 0 0 f f t f i 5 0 20 f "2283 2283 20 2283 20" _null_ _null_ _null_ _null_ linterp_int64 _null_ _null_ _null_ n ));
DESCR("linear interpolation: x, x0,y0, x1,y1");

/* linear_interpolate( anyelement, anyelement, int4, anyelement, int4) => int4 */ 
DATA(insert OID = 6073 ( linear_interpolate  PGNSP PGUID 12 1 0 0 f f t f i 5 0 23 f "2283 2283 23 2283 23" _null_ _null_ _null_ _null_ linterp_int32 _null_ _null_ _null_ n ));
DESCR("linear interpolation: x, x0,y0, x1,y1");

/* linear_interpolate( anyelement, anyelement, int2, anyelement, int2) => int2 */ 
DATA(insert OID = 6074 ( linear_interpolate  PGNSP PGUID 12 1 0 0 f f t f i 5 0 21 f "2283 2283 21 2283 21" _null_ _null_ _null_ _null_ linterp_int16 _null_ _null_ _null_ n ));
DESCR("linear interpolation: x, x0,y0, x1,y1");

/* linear_interpolate( anyelement, anyelement, float8, anyelement, float8) => float8 */ 
DATA(insert OID = 6075 ( linear_interpolate  PGNSP PGUID 12 1 0 0 f f t f i 5 0 701 f "2283 2283 701 2283 701" _null_ _null_ _null_ _null_ linterp_float8 _null_ _null_ _null_ n ));
DESCR("linear interpolation: x, x0,y0, x1,y1");

/* linear_interpolate( anyelement, anyelement, float4, anyelement, float4) => float4 */ 
DATA(insert OID = 6076 ( linear_interpolate  PGNSP PGUID 12 1 0 0 f f t f i 5 0 700 f "2283 2283 700 2283 700" _null_ _null_ _null_ _null_ linterp_float4 _null_ _null_ _null_ n ));
DESCR("linear interpolation: x, x0,y0, x1,y1");

/* linear_interpolate( anyelement, anyelement, date, anyelement, date) => date */ 
DATA(insert OID = 6077 ( linear_interpolate  PGNSP PGUID 12 1 0 0 f f t f i 5 0 1082 f "2283 2283 1082 2283 1082" _null_ _null_ _null_ _null_ linterp_DateADT _null_ _null_ _null_ n ));
DESCR("linear interpolation: x, x0,y0, x1,y1");

/* linear_interpolate( anyelement, anyelement, time, anyelement, time) => time */ 
DATA(insert OID = 6078 ( linear_interpolate  PGNSP PGUID 12 1 0 0 f f t f i 5 0 1083 f "2283 2283 1083 2283 1083" _null_ _null_ _null_ _null_ linterp_TimeADT _null_ _null_ _null_ n ));
DESCR("linear interpolation: x, x0,y0, x1,y1");

/* linear_interpolate( anyelement, anyelement, timestamp, anyelement, timestamp) => timestamp */ 
DATA(insert OID = 6079 ( linear_interpolate  PGNSP PGUID 12 1 0 0 f f t f i 5 0 1114 f "2283 2283 1114 2283 1114" _null_ _null_ _null_ _null_ linterp_Timestamp _null_ _null_ _null_ n ));
DESCR("linear interpolation: x, x0,y0, x1,y1");

/* linear_interpolate( anyelement, anyelement, timestamptz, anyelement, timestamptz) => timestamptz */ 
DATA(insert OID = 6080 ( linear_interpolate  PGNSP PGUID 12 1 0 0 f f t f i 5 0 1184 f "2283 2283 1184 2283 1184" _null_ _null_ _null_ _null_ linterp_TimestampTz _null_ _null_ _null_ n ));
DESCR("linear interpolation: x, x0,y0, x1,y1");

/* linear_interpolate( anyelement, anyelement, "interval", anyelement, "interval") => "interval" */ 
DATA(insert OID = 6081 ( linear_interpolate  PGNSP PGUID 12 1 0 0 f f t f i 5 0 1186 f "2283 2283 1186 2283 1186" _null_ _null_ _null_ _null_ linterp_Interval _null_ _null_ _null_ n ));
DESCR("linear interpolation: x, x0,y0, x1,y1");

/* linear_interpolate( anyelement, anyelement, "numeric", anyelement, "numeric") => "numeric" */ 
DATA(insert OID = 6082 ( linear_interpolate  PGNSP PGUID 12 1 0 0 f f t f i 5 0 1700 f "2283 2283 1700 2283 1700" _null_ _null_ _null_ _null_ linterp_Numeric _null_ _null_ _null_ n ));
DESCR("linear interpolation: x, x0,y0, x1,y1");

/* lead_lag_frame_maker(internal) => internal */ 
DATA(insert OID = 5081 ( lead_lag_frame_maker  PGNSP PGUID 12 1 0 0 f f t f v 1 0 2281 f "2281" _null_ _null_ _null_ _null_ lead_lag_frame_maker _null_ _null_ _null_ n ));

/* gp_dump_query_oids(text) => text */ 
DATA(insert OID = 6086 ( gp_dump_query_oids  PGNSP PGUID 12 1 0 0 f f t f v 1 0 25 f "25" _null_ _null_ _null_ _null_ gp_dump_query_oids _null_ _null_ _null_ n ));
DESCR("List function and relation OIDs that a query depends on, as a JSON object");

/* disable_xform(text) => text */ 
DATA(insert OID = 6087 ( disable_xform  PGNSP PGUID 12 1 0 0 f f t f i 1 0 25 f "25" _null_ _null_ _null_ _null_ disable_xform _null_ _null_ _null_ n ));
DESCR("disables transformations in the optimizer");

/* enable_xform(text) => text */ 
DATA(insert OID = 6088 ( enable_xform  PGNSP PGUID 12 1 0 0 f f t f i 1 0 25 f "25" _null_ _null_ _null_ _null_ enable_xform _null_ _null_ _null_ n ));
DESCR("enables transformations in the optimizer");

/* gp_opt_version() => text */ 
DATA(insert OID = 6089 ( gp_opt_version  PGNSP PGUID 12 1 0 0 f f t f i 0 0 25 f "" _null_ _null_ _null_ _null_ gp_opt_version _null_ _null_ _null_ n ));
DESCR("Returns the optimizer and gpos library versions");


  /* functions for the complex data type */
/* complex_in(cstring) => complex */ 
DATA(insert OID = 3991 ( complex_in  PGNSP PGUID 12 1 0 0 f f t f i 1 0 195 f "2275" _null_ _null_ _null_ _null_ complex_in _null_ _null_ _null_ n ));
DESCR("I/O");

/* complex_out(complex) => cstring */ 
DATA(insert OID = 3548 ( complex_out  PGNSP PGUID 12 1 0 0 f f t f i 1 0 2275 f "195" _null_ _null_ _null_ _null_ complex_out _null_ _null_ _null_ n ));
DESCR("I/O");

/* complex_recv(internal) => complex */ 
DATA(insert OID = 3549 ( complex_recv  PGNSP PGUID 12 1 0 0 f f t f i 1 0 195 f "2281" _null_ _null_ _null_ _null_ complex_recv _null_ _null_ _null_ n ));
DESCR("I/O");

/* complex_send(complex) => bytea */ 
DATA(insert OID = 3550 ( complex_send  PGNSP PGUID 12 1 0 0 f f t f i 1 0 17 f "195" _null_ _null_ _null_ _null_ complex_send _null_ _null_ _null_ n ));
DESCR("I/O");

/* complex(float8, float8) => complex */ 
DATA(insert OID = 3551 ( complex  PGNSP PGUID 12 1 0 0 f f t f i 2 0 195 f "701 701" _null_ _null_ _null_ _null_ construct_complex _null_ _null_ _null_ n ));
DESCR("constructs a complex number with given real part and imaginary part");

/* complex_trig(float8, float8) => complex */ 
DATA(insert OID = 3552 ( complex_trig  PGNSP PGUID 12 1 0 0 f f t f i 2 0 195 f "701 701" _null_ _null_ _null_ _null_ construct_complex_trig _null_ _null_ _null_ n ));
DESCR("constructs a complex number with given magnitude and phase");

/* re(complex) => float8 */ 
DATA(insert OID = 3553 ( re  PGNSP PGUID 12 1 0 0 f f t f i 1 0 701 f "195" _null_ _null_ _null_ _null_ complex_re _null_ _null_ _null_ n ));
DESCR("returns the real part of the argument");

/* im(complex) => float8 */ 
DATA(insert OID = 3554 ( im  PGNSP PGUID 12 1 0 0 f f t f i 1 0 701 f "195" _null_ _null_ _null_ _null_ complex_im _null_ _null_ _null_ n ));
DESCR("returns the imaginary part of the argument");

/* radians(complex) => float8 */ 
DATA(insert OID = 3555 ( radians  PGNSP PGUID 12 1 0 0 f f t f i 1 0 701 f "195" _null_ _null_ _null_ _null_ complex_arg _null_ _null_ _null_ n ));
DESCR("returns the phase of the argument");

/* complexabs(complex) => float8 */ 
DATA(insert OID = 3556 ( complexabs  PGNSP PGUID 12 1 0 0 f f t f i 1 0 701 f "195" _null_ _null_ _null_ _null_ complex_mag _null_ _null_ _null_ n ));
DESCR("returns the magnitude of the argument");

/* abs(complex) => float8 */ 
DATA(insert OID = 3557 ( abs  PGNSP PGUID 12 1 0 0 f f t f i 1 0 701 f "195" _null_ _null_ _null_ _null_ complex_mag _null_ _null_ _null_ n ));
DESCR("returns the magnitude of the argument");

/* conj(complex) => complex */ 
DATA(insert OID = 3558 ( conj  PGNSP PGUID 12 1 0 0 f f t f i 1 0 195 f "195" _null_ _null_ _null_ _null_ complex_conj _null_ _null_ _null_ n ));
DESCR("returns the conjunction of the argument");

/* hashcomplex(complex) => int4 */ 
DATA(insert OID = 3559 ( hashcomplex  PGNSP PGUID 12 1 0 0 f f t f i 1 0 23 f "195" _null_ _null_ _null_ _null_ complex_hash _null_ _null_ _null_ n ));
DESCR("hash");

/* complex_eq(complex, complex) => bool */ 
DATA(insert OID = 3560 ( complex_eq  PGNSP PGUID 12 1 0 0 f f t f i 2 0 16 f "195 195" _null_ _null_ _null_ _null_ complex_eq _null_ _null_ _null_ n ));
DESCR("equal");

/* complex_ne(complex, complex) => bool */ 
DATA(insert OID = 3561 ( complex_ne  PGNSP PGUID 12 1 0 0 f f t f i 2 0 16 f "195 195" _null_ _null_ _null_ _null_ complex_ne _null_ _null_ _null_ n ));
DESCR("not equal");

/* complex_pl(complex, complex) => complex */ 
DATA(insert OID = 3562 ( complex_pl  PGNSP PGUID 12 1 0 0 f f t f i 2 0 195 f "195 195" _null_ _null_ _null_ _null_ complex_pl _null_ _null_ _null_ n ));
DESCR("plus");

/* complex_up(complex) => complex */ 
DATA(insert OID = 3563 ( complex_up  PGNSP PGUID 12 1 0 0 f f t f i 1 0 195 f "195" _null_ _null_ _null_ _null_ complex_up _null_ _null_ _null_ n ));
DESCR("unary plus");

/* complex_mi(complex, complex) => complex */ 
DATA(insert OID = 3564 ( complex_mi  PGNSP PGUID 12 1 0 0 f f t f i 2 0 195 f "195 195" _null_ _null_ _null_ _null_ complex_mi _null_ _null_ _null_ n ));
DESCR("minus");

/* complex_um(complex) => complex */ 
DATA(insert OID = 3565 ( complex_um  PGNSP PGUID 12 1 0 0 f f t f i 1 0 195 f "195" _null_ _null_ _null_ _null_ complex_um _null_ _null_ _null_ n ));
DESCR("unary minus");

/* complex_mul(complex, complex) => complex */ 
DATA(insert OID = 3566 ( complex_mul  PGNSP PGUID 12 1 0 0 f f t f i 2 0 195 f "195 195" _null_ _null_ _null_ _null_ complex_mul _null_ _null_ _null_ n ));
DESCR("multiply");

/* complex_div(complex, complex) => complex */ 
DATA(insert OID = 3567 ( complex_div  PGNSP PGUID 12 1 0 0 f f t f i 2 0 195 f "195 195" _null_ _null_ _null_ _null_ complex_div _null_ _null_ _null_ n ));
DESCR("divide");

/* complex_power(complex, complex) => complex */ 
DATA(insert OID = 3568 ( complex_power  PGNSP PGUID 12 1 0 0 f f t f i 2 0 195 f "195 195" _null_ _null_ _null_ _null_ complex_pow _null_ _null_ _null_ n ));
DESCR("exponentiation (x^y)");

/* complex_sqrt(complex) => complex */ 
DATA(insert OID = 3569 ( complex_sqrt  PGNSP PGUID 12 1 0 0 f f t f i 1 0 195 f "195" _null_ _null_ _null_ _null_ complex_sqrt _null_ _null_ _null_ n ));
DESCR("squre root");

/* complex_cbrt(complex) => complex */ 
DATA(insert OID = 3570 ( complex_cbrt  PGNSP PGUID 12 1 0 0 f f t f i 1 0 195 f "195" _null_ _null_ _null_ _null_ complex_cbrt _null_ _null_ _null_ n ));
DESCR("cube root");

/* degrees(complex) => float8 */ 
DATA(insert OID = 3571 ( degrees  PGNSP PGUID 12 1 0 0 f f t f i 1 0 701 f "195" _null_ _null_ _null_ _null_ complex_degrees _null_ _null_ _null_ n ));
DESCR("phase to degrees");

/* exp(complex) => complex */ 
DATA(insert OID = 3572 ( exp  PGNSP PGUID 12 1 0 0 f f t f i 1 0 195 f "195" _null_ _null_ _null_ _null_ complex_exp _null_ _null_ _null_ n ));
DESCR("natural exponential (e^x)");

/* ln(complex) => complex */ 
DATA(insert OID = 3573 ( ln  PGNSP PGUID 12 1 0 0 f f t f i 1 0 195 f "195" _null_ _null_ _null_ _null_ complex_ln _null_ _null_ _null_ n ));
DESCR("natural logarithm");

/* log(complex) => complex */ 
DATA(insert OID = 3574 ( log  PGNSP PGUID 12 1 0 0 f f t f i 1 0 195 f "195" _null_ _null_ _null_ _null_ complex_log10 _null_ _null_ _null_ n ));
DESCR("base 10 logarithm");

/* log(complex, complex) => complex */ 
DATA(insert OID = 3575 ( log  PGNSP PGUID 12 1 0 0 f f t f i 2 0 195 f "195 195" _null_ _null_ _null_ _null_ complex_log _null_ _null_ _null_ n ));
DESCR("logarithm base arg1 of arg2");

/* acos(complex) => complex */ 
DATA(insert OID = 3576 ( acos  PGNSP PGUID 12 1 0 0 f f t f i 1 0 195 f "195" _null_ _null_ _null_ _null_ complex_acos _null_ _null_ _null_ n ));
DESCR("acos");

/* asin(complex) => complex */ 
DATA(insert OID = 3577 ( asin  PGNSP PGUID 12 1 0 0 f f t f i 1 0 195 f "195" _null_ _null_ _null_ _null_ complex_asin _null_ _null_ _null_ n ));
DESCR("asin");

/* atan(complex) => complex */ 
DATA(insert OID = 3578 ( atan  PGNSP PGUID 12 1 0 0 f f t f i 1 0 195 f "195" _null_ _null_ _null_ _null_ complex_atan _null_ _null_ _null_ n ));
DESCR("atan");

/* cos(complex) => complex */ 
DATA(insert OID = 3579 ( cos  PGNSP PGUID 12 1 0 0 f f t f i 1 0 195 f "195" _null_ _null_ _null_ _null_ complex_cos _null_ _null_ _null_ n ));
DESCR("cos");

/* cot(complex) => complex */ 
DATA(insert OID = 3580 ( cot  PGNSP PGUID 12 1 0 0 f f t f i 1 0 195 f "195" _null_ _null_ _null_ _null_ complex_cot _null_ _null_ _null_ n ));
DESCR("cot");

/* sin(complex) => complex */ 
DATA(insert OID = 3581 ( sin  PGNSP PGUID 12 1 0 0 f f t f i 1 0 195 f "195" _null_ _null_ _null_ _null_ complex_sin _null_ _null_ _null_ n ));
DESCR("sin");

/* tan(complex) => complex */ 
DATA(insert OID = 3582 ( tan  PGNSP PGUID 12 1 0 0 f f t f i 1 0 195 f "195" _null_ _null_ _null_ _null_ complex_tan _null_ _null_ _null_ n ));
DESCR("tan");

/* dotproduct(_complex, _complex) => complex */ 
DATA(insert OID = 3583 ( dotproduct  PGNSP PGUID 12 1 0 0 f f t f i 2 0 195 f "196 196" _null_ _null_ _null_ _null_ complex_dot_product _null_ _null_ _null_ n ));
DESCR("dot product");

/* float82complex(float8) => complex */ 
DATA(insert OID = 3584 ( float82complex  PGNSP PGUID 12 1 0 0 f f t f i 1 0 195 f "701" _null_ _null_ _null_ _null_ float82complex _null_ _null_ _null_ n ));
DESCR("(internal) type cast from float8 to complex");

/* float42complex(float4) => complex */ 
DATA(insert OID = 3585 ( float42complex  PGNSP PGUID 12 1 0 0 f f t f i 1 0 195 f "700" _null_ _null_ _null_ _null_ float42complex _null_ _null_ _null_ n ));
DESCR("(internal) type cast from float4 to complex");

/* int82complex(int8) => complex */ 
DATA(insert OID = 3586 ( int82complex  PGNSP PGUID 12 1 0 0 f f t f i 1 0 195 f "20" _null_ _null_ _null_ _null_ int82complex _null_ _null_ _null_ n ));
DESCR("(internal) type cast from int8 to complex");

/* int42complex(int4) => complex */ 
DATA(insert OID = 3587 ( int42complex  PGNSP PGUID 12 1 0 0 f f t f i 1 0 195 f "23" _null_ _null_ _null_ _null_ int42complex _null_ _null_ _null_ n ));
DESCR("(internal) type cast from int4 to complex");

/* int22complex(int2) => complex */ 
DATA(insert OID = 3588 ( int22complex  PGNSP PGUID 12 1 0 0 f f t f i 1 0 195 f "21" _null_ _null_ _null_ _null_ int22complex _null_ _null_ _null_ n ));
DESCR("(internal) type cast from int2 to complex");

/* power(complex, complex) => complex */ 
DATA(insert OID = 3589 ( power  PGNSP PGUID 12 1 0 0 f f t f i 2 0 195 f "195 195" _null_ _null_ _null_ _null_ complex_pow _null_ _null_ _null_ n ));
DESCR("exponentiation (x^y)");

/* sqrt(complex) => complex */ 
DATA(insert OID = 3590 ( sqrt  PGNSP PGUID 12 1 0 0 f f t f i 1 0 195 f "195" _null_ _null_ _null_ _null_ complex_sqrt _null_ _null_ _null_ n ));
DESCR("squre root");

/* cbrt(complex) => complex */ 
DATA(insert OID = 3591 ( cbrt  PGNSP PGUID 12 1 0 0 f f t f i 1 0 195 f "195" _null_ _null_ _null_ _null_ complex_cbrt _null_ _null_ _null_ n ));
DESCR("cube root");

/* numeric2point("numeric") => complex */ 
DATA(insert OID = 3592 ( numeric2point  PGNSP PGUID 12 1 0 0 f f t f i 1 0 195 f "1700" _null_ _null_ _null_ _null_ numeric2complex _null_ _null_ _null_ n ));
DESCR("(internal) type cast from numeric to complex");

/* complex_lt(complex, complex) => bool */ 
DATA(insert OID = 3593 ( complex_lt  PGNSP PGUID 12 1 0 0 f f t f i 2 0 16 f "195 195" _null_ _null_ _null_ _null_ complex_lt _null_ _null_ _null_ n ));
DESCR("less than");

/* complex_gt(complex, complex) => bool */ 
DATA(insert OID = 3594 ( complex_gt  PGNSP PGUID 12 1 0 0 f f t f i 2 0 16 f "195 195" _null_ _null_ _null_ _null_ complex_gt _null_ _null_ _null_ n ));
DESCR("greater than");

/* complex_lte(complex, complex) => bool */ 
DATA(insert OID = 3595 ( complex_lte  PGNSP PGUID 12 1 0 0 f f t f i 2 0 16 f "195 195" _null_ _null_ _null_ _null_ complex_lte _null_ _null_ _null_ n ));
DESCR("less than or equal");

/* complex_gte(complex, complex) => bool */ 
DATA(insert OID = 3596 ( complex_gte  PGNSP PGUID 12 1 0 0 f f t f i 2 0 16 f "195 195" _null_ _null_ _null_ _null_ complex_gte _null_ _null_ _null_ n ));
DESCR("greater than or equal");


 /* functions for external table */
/* pg_options_to_table(IN options_array _text, OUT option_name text, OUT option_value text) => SETOF pg_catalog.record */ 
DATA(insert OID = 2022 ( pg_options_to_table  PGNSP PGUID 12 1 1000 0 f f t t i 1 0 2249 f "1009" "{1009,25,25}" "{i,o,o}" "{options_array,option_name,option_value}" _null_ pg_options_to_table _null_ _null_ _null_ n ));
DESCR("convert generic options array to name/value table");


/* TIDYCAT_END_PG_PROC_GEN */
